<?php

namespace App\Helpers;

use App\Models\Client;
use App\Models\Clienteswispro;
use App\Models\CodigoRecaudacion;
use App\Models\ErrorQr;
use App\Models\Factura;
use App\Models\ImagenQr;
use App\Models\ListaNegra;
use App\Models\Mespagado;
use App\Models\Pago;
use App\Models\PagoAdelantado;
use App\Models\PagoDetalle;
use App\Models\PagoSintesi;
use App\Models\PagoWispro;
use App\Models\Plan;
use App\Models\Qr;
use App\Models\Sintesi;
use App\Models\User;
use App\Models\Wisprocron;
use Illuminate\Support\Facades\DB;
use DateTime;
use DateTimeZone;
use DOMDocument;
use Egulias\EmailValidator\Result\ValidEmail;
use Illuminate\Support\Facades\Http;
use Illuminate\Support\Facades\Log;

class Helpers
{
    public static function peticionGetSmartOlt($ruta, $id)
    {

        $url_base = 'https://internethome.smartolt.com/api/onu/' . $ruta . $id; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        return $response;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function peticionGetWispro($ruta, $id)
    {


        $url_base = 'https://www.cloud.wispro.co/api/v1/' . $ruta . $id; //$request->token;

        // dd($url_base);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        return $response;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function obtenerTodosLosPlanesWispro()
    {


        $url_base = 'https://www.cloud.wispro.co/api/v1/plans'; //$request->token;

        // dd($url_base);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        return $response;
        $datos = json_decode($response);
        return response()->json($datos->data, 200);
    }
    public static function obtenerTodosLosClientesWispro()
    {
        ini_set('max_execution_time', 360000);
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_page($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;

        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_page($current_page, $per_page);
            $dataClientes = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($dataClientes as $cliente) {

                $cont++;
                $clientes_custom_ids[] = ['client_id' => $cliente['id'], 'custom_id' => $cliente['custom_id']];
            }
        }
        return $clientes_custom_ids;
        //  $dataTodoLosClientes = $datosTodosLosClientes['data'];


        // return $clientes_custom_ids;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function obtenerTodosLosClientesWisproBBDD()
    {
        ini_set('max_execution_time', 360000);
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_page($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;

        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_page($current_page, $per_page);
            $dataClientes = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($dataClientes as $cliente) {

                $cont++;
                //  $clientes_custom_ids[] = ['client_id' => $cliente['id'], 'custom_id' => $cliente['custom_id']];
                $client = new Clienteswispro();
                $client->client_id = $cliente['id'];
                $client->custom_id = $cliente['custom_id'];
                $client->name = $cliente['name'];
                $client->save();
            }
        }
        //return $clientes_custom_ids;
        return true;
        //  $dataTodoLosClientes = $datosTodosLosClientes['data'];


        // return $clientes_custom_ids;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function obtenerTodosLosContratosWispro($idPlan)
    {
        ini_set('max_execution_time', 36000);
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_pageContratos($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;

        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_pageContratos($current_page, $per_page);
            $listaContratos = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($listaContratos as $contrato) {

                $cont++;
                if ($contrato['plan_id'] === $idPlan) {

                    // $contartos_idplan[] = ['client_id' => $contrato['id'], 'custom_id' => $contrato['custom_id']];
                    $contratos_idplan[] = $contrato['client_id'];
                }
            }
            sleep(3);
        }
        return $contratos_idplan;
        //  $dataTodoLosClientes = $datosTodosLosClientes['data'];


        // return $clientes_custom_ids;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function obtenerTodosLosContratosWisproPlanODeshabilitadoBBDD($idPlan)
    {
        ini_set('max_execution_time', 36000);
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_pageContratos($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;

        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_pageContratos($current_page, $per_page);
            $listaContratos = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($listaContratos as $contrato) {
                //me parece que tarda

                $cont++;
                if ($contrato['plan_id'] === $idPlan || $contrato['state'] === 'disabled') {
                    // $contartos_idplan[] = ['client_id' => $contrato['id'], 'custom_id' => $contrato['custom_id']];
                    $contratos_idplan[] = $contrato['client_id'];

                    $wisp = new Wisprocron();
                    $wisp->contrato_id = $contrato['id'];
                    $wisp->plan_id = $contrato['plan_id'];
                    $wisp->client_id = $contrato['client_id'];
                    $wisp->latitude = $contrato['latitude'];
                    $wisp->longitude = $contrato['longitude'];
                    $wisp->state = $contrato['state'];
                    $wisp->save();
                }
            }
            sleep(3);
        }
        return $contratos_idplan;
        //  $dataTodoLosClientes = $datosTodosLosClientes['data'];


        // return $clientes_custom_ids;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function guardarTodosLosContratosWisproPlan178BBDD($idPlan)
    {
        ini_set('max_execution_time', 36000);
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_pageContratos($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;



        $plan198 = "7df87286-d67e-4cae-9e52-d2b16f230cd2";
        $plan200 = "c8d276fd-a48e-41c3-a8c9-bbd181e0d860";
        $plan208 = "fda40133-bba6-4e5e-859e-d9604fae3906";
        $plan225 = "332186cd-e4dc-472f-b0a3-665111f159a5";
        $plan258 = "a6e963ad-ff46-4aac-bbcc-1b785edf835e";
        $plan286 = "fd3b8a6c-eff7-4439-be0f-4ae72de6c09f";
        $plan335 = "90a88865-dcd5-4db1-a21e-79211b0959a4";
        $plan385 = "f71ac620-dfb1-48bf-b2a3-4b9a020313c2";
        $plan482 = "6f84d62c-906f-4336-a37e-070da4074ca4";


        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_pageContratos($current_page, $per_page);
            $listaContratos = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($listaContratos as $contrato) {
                //me parece que tarda

                $cont++;
                if ($contrato['state'] === 'enabled') {
                    switch ($contrato['plan_id']) {
                        case $idPlan:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 178.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan198:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 198.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan200:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 200.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan208:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 208.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan225:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 225.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan258:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 258.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan286:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 286.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan335:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 335.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan385:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 385.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                        case $plan482:
                            $contratos_idplan[] = $contrato['client_id'];

                            $wisp = new Wisprocron();
                            $wisp->contrato_id = $contrato['id'];
                            $wisp->plan_id = $contrato['plan_id'];
                            $wisp->client_id = $contrato['client_id'];
                            $wisp->precio = 482.0;
                            $wisp->state = $contrato['state'];
                            //$wisp->latitude = $contrato['latitude'];
                            // $wisp->longitude = $contrato['longitude'];

                            $wisp->save();
                            break;
                    }
                    // if ($contrato['plan_id'] === $idPlan || $contrato['plan_id'] === $plan198 || $contrato['plan_id'] === $plan200 || $contrato['plan_id'] === $plan208 || $contrato['plan_id'] === $plan225 || $contrato['plan_id'] === $plan258 || $contrato['plan_id'] === $plan286 || $contrato['plan_id'] === $plan335 || $contrato['plan_id'] === $plan385 || $contrato['plan_id'] === $plan482) {
                    //     // $contartos_idplan[] = ['client_id' => $contrato['id'], 'custom_id' => $contrato['custom_id']];
                    //     $contratos_idplan[] = $contrato['client_id'];

                    //     $wisp = new Wisprocron();
                    //     $wisp->contrato_id = $contrato['id'];
                    //     $wisp->plan_id = $contrato['plan_id'];
                    //     $wisp->client_id = $contrato['client_id'];
                    //     $wisp->state = $contrato['state'];
                    //     //$wisp->latitude = $contrato['latitude'];
                    //     // $wisp->longitude = $contrato['longitude'];

                    //     $wisp->save();
                    // }
                }
            }
            sleep(3);
        }
        return $contratos_idplan;
        //  $dataTodoLosClientes = $datosTodosLosClientes['data'];


        // return $clientes_custom_ids;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function obtenerTodosLosContratosDisabled()
    {
        ini_set('max_execution_time', 360000);
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_pageContratosDisabled($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;

        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_pageContratosDisabled($current_page, $per_page);
            $listaContratos = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($listaContratos as $contrato) {

                $contratos_idplan[] = $contrato['client_id'];
                $cont++;
                /*
                if ($contrato['plan_id'] === $idPlan) {

                    // $contartos_idplan[] = ['client_id' => $contrato['id'], 'custom_id' => $contrato['custom_id']];
                    $contratos_idplan[] = $contrato['client_id'];
                }
                */
            }
            sleep(1);
        }
        return $contratos_idplan;
        //  $dataTodoLosClientes = $datosTodosLosClientes['data'];


        // return $clientes_custom_ids;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function records_page($page, $per_page)
    {


        $url_base = 'https://www.cloud.wispro.co/api/v1/clients?page=' . $page . '&per_page=' . $per_page; //$request->token;

        // dd($url_base);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        $datosTodosLosClientes = json_decode($response, true);
        return $datosTodosLosClientes;
    }
    public static function records_pageContratos($page, $per_page)
    {


        $url_base = 'https://www.cloud.wispro.co/api/v1/contracts?page=' . $page . '&per_page=' . $per_page; //$request->token;

        // dd($url_base);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        $datosTodosLosClientes = json_decode($response, true);
        return $datosTodosLosClientes;
    }
    public static function records_pageContratosDisabled($page, $per_page)
    {


        $url_base = 'https://www.cloud.wispro.co/api/v1/contracts?state_eq=disabled&page=' . $page . '&per_page=' . $per_page; //$request->token;

        // dd($url_base);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        $datosTodosLosClientes = json_decode($response, true);
        return $datosTodosLosClientes;
    }
    public static function peticionGetWisproAll($ruta)
    {


        $url_base = 'https://www.cloud.wispro.co/api/v1/' . $ruta; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        return $response;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function obtenerCustomIdClientWispro($ruta, $id)
    {

        //https://www.cloud.wispro.co/api/v1/clients/19e11a3d-3844-44a4-8b3a-cc67e3eff2da
        $url_base = 'https://www.cloud.wispro.co/api/v1/' . $ruta . $id; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        $datosStatus = json_decode($response, true);
        // $datosArray = json_decode($responseStatus, true);
        // $countries = $datosStatus['data'];
        $customID = '';
        //foreach ($countries as $country) {
        //  echo ' visited ' . $country['id'] . ' in ' . $country['invoice_number'] . 'P.\n';
        //  $ids_facturas_a_pagar[] = $country['id'];
        //  $customID = $country['custom_id'];
        //}

        return $datosStatus;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function habilitarContrato($uuid)
    {

        //https://www.cloud.wispro.co/api/v1/clients/19e11a3d-3844-44a4-8b3a-cc67e3eff2da
        $url_base = 'https://www.cloud.wispro.co/api/v1/contracts/' . $uuid; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->put($url_base, [
            'state' => 'enabled'
        ]);

        $datosStatus = json_decode($response, true);
        // $datosArray = json_decode($responseStatus, true);
        // $countries = $datosStatus['data'];

        //foreach ($countries as $country) {
        //  echo ' visited ' . $country['id'] . ' in ' . $country['invoice_number'] . 'P.\n';
        //  $ids_facturas_a_pagar[] = $country['id'];
        //  $customID = $country['custom_id'];
        //}

        return $datosStatus;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function deshabilitarContrato($uuid)
    {

        //https://www.cloud.wispro.co/api/v1/clients/19e11a3d-3844-44a4-8b3a-cc67e3eff2da
        $url_base = 'https://www.cloud.wispro.co/api/v1/contracts/' . $uuid; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->put($url_base, [
            'state' => 'disabled'
        ]);

        $datosStatus = json_decode($response, true);
        // $datosArray = json_decode($responseStatus, true);
        // $countries = $datosStatus['data'];
        $customID = '';
        //foreach ($countries as $country) {
        //  echo ' visited ' . $country['id'] . ' in ' . $country['invoice_number'] . 'P.\n';
        //  $ids_facturas_a_pagar[] = $country['id'];
        //  $customID = $country['custom_id'];
        //}

        return $datosStatus;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function peticionGetAuthBnb()
    {
        //http://test.bnb.com.bo/ClientAuthentication.API/api/v1/auth/token
        //http://test.bnb.com.bo/ClientAuthentication.API/api/v1/auth/UpdateCredentials

        $url_base = 'http://test.bnb.com.bo/ClientAuthentication.API/api/v1/auth/token'; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'accountId' => 'G42MV/9MPUREiXvRxcCScQ==',
            'authorizationId' => 'S1stemas00$1sbol',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        return $response;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }
    public static function updateCredentialsBnb()
    {

        //http://test.bnb.com.bo/ClientAuthentication.API/api/v1/auth/UpdateCredentials

        $url_base = 'http://test.bnb.com.bo/ClientAuthentication.API/api/v1/auth/UpdateCredentials'; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'accountId' => 'G42MV/9MPUREiXvRxcCScQ==',
            'actualAuthorizationId' => 'S1stemas00$1sbol',
            'newAuthorizationId' => 'S1stemas00$1sbol1234',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        return $response;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }

    public static function peticionGetEndPointsBnb($ruta, $gloss)
    {
        //http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync
        //http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRbyGenerationDateAsync
        //http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRStatusAsync
        //http://test.bnb.com.bo/QRSimple.API/api/v1/main/CancelQRByIdAsync

        // $url_base = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/' . $ruta . $id; //$request->token;

        //dd($token4);
        /*
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
    */
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        //        return $response;
        // $datos = json_decode($response);
        // return response()->json($datos, 200);
    }

    public static function deshabilitar_cattv($id)
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/onu/disable_catv/' . $id; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => '*/*',
            'Accept' => 'application/json',

        ])->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        //$datos = json_decode($response);
        return $response;
    }
    public static function verifica_estado_cattv($id)
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/onu/get_onu_catv_status/' . $id; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => '*/*',
            'Accept' => 'application/json',

        ])->get($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        $datos = json_decode($response);
        return $datos;
    }
    public static function deshabilitar_multiple_cattv($text)
    {
        //

        ini_set('max_execution_time', 36000);
        // $text = "200020,200040,200050,200042";
        $token4 = 'https://internethome.smartolt.com/api/onu/bulk_disable_catv'; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => '*/*',
            'Accept' => 'application/json',

        ])->attach('onus_external_ids', $text)->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response;
    }
    public static function apagarOnus($text)
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/onu/bulk_disable'; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->attach('onus_external_ids', $text)->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function obtenerListaTiposOnu()
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/system/get_onu_types'; //$request->token;
        //dd($token4);

        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->get($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function obtenerTodaListaOnusEstado()
    {
        //
        ini_set('max_execution_time', 360000);
        // $token4 = 'https://internethome.smartolt.com/api/onu/get_onus_statuses'; //$request->token;
        // $token4 = 'https://internethome.smartolt.com/api/onu/get_all_onus_details'; //$request->token;
        $token4 = 'https://internethome.smartolt.com/api/onu/get_all_onus_details'; //$request->token;
        //dd($token4);

        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->get($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function EncenderOnus($text)
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/onu/bulk_enable'; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->attach('onus_external_ids', $text)->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function habilitar_multiple_cattv($text)
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/onu/bulk_enable_catv'; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->attach('onus_external_ids', $text)->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function pageInvoice($client_id, $invoice_ids, $amount, $comment)
    {
        date_default_timezone_set('America/La_Paz');
        try {
            //code...
            $invoice_ids2 = [];
            $funca = date('Y-m-d h:i:s');
            $datetime = new DateTime($funca, new DateTimeZone('America/La_Paz'));
            //echo "************************************<br>";
            $tiempo = $datetime->format(DateTime::ATOM);

            // $client_id = "099e0d61-f558-4c46-b816-cc8fee3321e6";
            $client_idd = $client_id;
            array_push($invoice_ids2, $invoice_ids);
            $invoice_idss = $invoice_ids; //["4c81932a-2bbc-4a35-b372-878f61ba508a", "34592a3e-6d74-4a3e-b562-da4f25e61cad", "c6694599-970c-4677-9376-7f8de1c0a192"];
            $amounts = $amount;
            $payment_date = $tiempo; //"2023-06-13T17:35:54.804-04:00";
            $comments = $comment;
            // $comment = "Pago realizado por porfy";

            //$token4 = 'https://internethome.smartolt.com/api/onu/enable_catv/' . $id; 
            $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/payments';
            //dd($token4);
            $responsePago = Http::withHeaders([
                'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
                'accept' => 'application/json',

            ])->post($token4, [
                'client_id' => $client_id,
                'invoice_ids' => $invoice_ids,
                'amount' => $amount,
                'payment_date' => $payment_date,
                'transaction_kind_id' => 'f2d6e213-9259-49f7-864a-0a25824f473e',
                'comment' => $comment
            ]);
            Log::info("Pago realizado con exito ::> client_id==>" . $client_id . ' ' . now());
            Log::info("Pago realizado con exito ::> client_id==>" . $responsePago . ' ' . now());
            return $responsePago;
            return response()->json([
                'success' => true,
                'mensaje' => 'Pago realizado con exito',
                'ids' => $invoice_ids
            ], 200);
        } catch (\Exception $e) {
            Log::info("Error al realizar el pago de la factura. ::> client_id==>" . $client_id);
            return response()->json([
                "status" => false,
                "mensaje" => "Error al realizar el pago de la factura.",

            ], 422);
        }
    }
    public static function pageInvoiceSintesis($client_id, $invoice_ids, $amount, $comment)
    {
        date_default_timezone_set('America/La_Paz');
        try {
            //code...
            $invoice_ids2 = [];
            $funca = date('Y-m-d h:i:s');
            $datetime = new DateTime($funca, new DateTimeZone('America/La_Paz'));
            //echo "************************************<br>";
            $tiempo = $datetime->format(DateTime::ATOM);

            // $client_id = "099e0d61-f558-4c46-b816-cc8fee3321e6";
            $client_idd = $client_id;
            array_push($invoice_ids2, $invoice_ids);
            $invoice_idss = $invoice_ids; //["4c81932a-2bbc-4a35-b372-878f61ba508a", "34592a3e-6d74-4a3e-b562-da4f25e61cad", "c6694599-970c-4677-9376-7f8de1c0a192"];
            $amounts = $amount;
            $payment_date = $tiempo; //"2023-06-13T17:35:54.804-04:00";
            $comments = $comment;
            // $comment = "Pago realizado por porfy";

            //$token4 = 'https://internethome.smartolt.com/api/onu/enable_catv/' . $id; 
            $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/payments';
            //dd($token4);
            $responsePago = Http::withHeaders([
                'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
                'accept' => 'application/json',

            ])->post($token4, [
                'client_id' => $client_id,
                'invoice_ids' => $invoice_ids,
                'amount' => $amount,
                'payment_date' => $payment_date,
                'transaction_kind_id' => '6140d990-b615-4499-b4b3-aaba77f743ea',
                'comment' => $comment
            ]);
            return response()->json([
                'success' => true,
                'mensaje' => 'Pago realizado con exito',
                'ids' => $invoice_ids
            ], 200);
        } catch (\Exception $e) {

            return response()->json([
                "status" => false,
                "mensaje" => "Error al realizar el pago de la factura.",

            ], 422);
        }
    }
    public static function getBalance($client_id)
    {

        //  try {

        $url_base = 'https://www.cloud.wispro.co/api/v1/clients/' . $client_id . '/current_account';


        $responseBalance = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($url_base);
        return $responseBalance;
        /*
        } catch (\Exception $e) {

            return response()->json([
                "status" => false,
                "mensaje" => "Error al obtener el saldo del cliente.",

            ], 422);
        }*/
    }
    public static function habilitar_cattv($id)
    {
        //
        ini_set('max_execution_time', 36000);
        $token4 = 'https://internethome.smartolt.com/api/onu/enable_catv/' . $id; //$request->token;
        //dd($token4);

        $email = 'porfirio@gmail.com';
        $address = 'Zona Porvenir';
        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function rebootSmart($customId)
    {
        //
        $token4 = 'https://internethome.smartolt.com/api/onu/reboot/' . $customId; //$request->token;
        //dd($token4);


        $response = Http::withHeaders([
            'X-Token' => 'f4937d81d82741668155119e82b13a8f',
            'Accept' => 'application/json',

        ])->post($token4);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        // $datos = json_decode($response);
        return $response; //()->json($datos, 200);
    }
    public static function facturasPendientes($nro_ci)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=pending&client_national_identification_number_eq=1234569
        $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=pending&client_national_identification_number_eq=' . $nro_ci;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        return $datos; //()->json($datos, 200);
    }
    public static function facturasPendientesPorCustomID($customID)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=pending&client_national_identification_number_eq=1234569
        $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=pending&client_custom_id_eq=' . $customID;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        return $datos; //()->json($datos, 200);
    }
    public static function obtenerClienteId($id)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=200040
        $token4 = 'https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=' . $id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data'];
        $datos = $datos[0];
        $id = $datos['id'];
        $name = $datos['name'];
        return [$id, $name]; //()->json($datos, 200);
    }
    public static function obtenerCustomIdCliente($id)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=200040
        $token4 = 'https://www.cloud.wispro.co/api/v1/clients/' . $id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data'];
        // $datos = $datos[0];
        // $id = $datos['id'];
        // $name = $datos['name'];
        return $datos;
        return [$id, $name]; //()->json($datos, 200);
    }
    public static function obtenerClienteUUId($customID)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=200040
        $token4 = 'https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=' . $customID;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data'];
        $datos = $datos[0];
        $id = $datos['id'];

        return $id; //()->json($datos, 200);
    }
    public static function obtenerTodosLosClienteWispro()
    {
        $url = 'https://www.cloud.wispro.co/api/v1/clients';
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($url);
        $datos = json_decode($response, true);
        $datos = $datos['meta'];
        $pagination = $datos['pagination'];
        $total_records = $datos['total_records'];
        // $name = $datos['name'];
        return $total_records; //()->json($datos, 200);
    }
    public static function obtenerTodosLosUsuarioSistema()
    {
        $url = 'https://www.cloud.wispro.co/api/v1/clients';
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($url);
        $datos = json_decode($response, true);
        $datos = $datos['meta'];
        $datos = $datos['pagination'];
        $total_records = $datos['total_records'];
        // $name = $datos['name'];
        return $total_records; //()->json($datos, 200);
    }
    public static function obtenerClientesXCI($nro_ci)
    {

        //
        //*************funca***************** */

        $token4 = 'https://www.cloud.wispro.co/api/v1/clients?national_identification_number_eq=' . $nro_ci;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        // $datos = $datos['data'];
        // $datos = $datos[0];
        // $id = $datos['id'];
        // $name = $datos['name'];
        return $datos;
    }
    public static function buscarNuevoClientesXCI($custom_id, $nro_ci)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=200040
        $token4 = 'https://www.cloud.wispro.co/api/v1/clients?custom_id_eq=' . $custom_id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);

        if ($datos['data'] != null) {
            $datos = $datos['data'];
            if ($nro_ci == $datos[0]['national_identification_number'] && $custom_id == $datos[0]['custom_id']) {

                $client2 = Client::select('user_id')
                    ->where("national_identification_number", $nro_ci)
                    ->get();
                if (count($client2)) {
                    $client = new Client();
                    $client->id_wispro = $datos[0]['id']; //$request->id_wispro;
                    // $client->public_id = $request->public_id;
                    $client->custom_id = $datos[0]['custom_id']; //$request->custom_id;
                    $client->name = $datos[0]['name']; //$request->name;
                    $client->email = $datos[0]['email']; //$request->email2;
                    $client->address = $datos[0]['address']; //$request->address;
                    $client->phone_mobile = $datos[0]['phone_mobile']; //$request->phone_mobile;
                    $client->national_identification_number = $datos[0]['national_identification_number']; //$request->national_identification_number;
                    $client->city = $datos[0]['city']; //$request->city;
                    $client->state = $datos[0]['state']; //$request->state;
                    $client->details = $datos[0]['details']; //$request->details;
                    // $client->created_at_wispro = $request->created_at_wispro;
                    $client->user_id = $client2->user_id;


                    $client->save();
                    return true;
                } else {
                    DB::beginTransaction();
                    $cantidad_clientes = Helpers::obtenerClientesXCI($nro_ci);
                    // $cliente['custom_id']   
                    $cantidad_clientes = $cantidad_clientes['data'];
                    try {
                        $usuario = new User();
                        $usuario->name = $custom_id;
                        $usuario->email = $custom_id;
                        $usuario->registrado = 1;
                        $usuario->cuenta = 1; // 
                        $usuario->password = bcrypt($nro_ci);
                        $usuario->save();
                        $usuario->assignRole("User");

                        //obtenemos clientes

                        //registro de clientes 
                        foreach ($cantidad_clientes as $cliente) {
                            $client = new Client();
                            $client->id_wispro = $cliente['id']; //$request->id_wispro;
                            // $client->public_id = $request->public_id;
                            $client->custom_id = $cliente['custom_id']; //$request->custom_id;
                            $client->name = $cliente['name']; //$request->name;
                            $client->email = $cliente['email']; //$request->email2;
                            $client->address = $cliente['address']; //$request->address;
                            $client->phone_mobile = $cliente['phone_mobile']; //$request->phone_mobile;
                            $client->national_identification_number = $cliente['national_identification_number']; //$request->national_identification_number;
                            $client->city = $cliente['city']; //$request->city;
                            $client->state = $cliente['state']; //$request->state;
                            $client->details = $cliente['details']; //$request->details;
                            // $client->created_at_wispro = $request->created_at_wispro;
                            $client->user_id = $usuario->id;

                            $client->save();
                        }

                        DB::commit();
                        // responder
                        return response()->json([
                            "status" => true,
                            "mensaje" => "Cliente registrado correctamente",
                            // 'name' => $request->name,
                            // 'email' => $request->email,
                            // 'password' => $request->password,
                        ], 201);
                    } catch (\Exception $e) {
                        DB::rollBack();
                        return response()->json([
                            "status" => false,
                            "mensaje" => "Error al registrar al Cliente.",

                            // 'name' => $request->name,
                            // 'email' => $request->email,
                            // 'password' => $request->password,
                        ], 422);
                    }
                }
            }
        } else {
            return false;
        }

        //return $datos;
        // $datos = $datos[0];
        // $id = $datos['id'];
        // $name = $datos['name'];
    }
    public static function obtenerClienteXUuid($uuid)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/clients/3aa54cb8-ce91-44c2-8d0e-c857ef2fecd5
        $token4 = 'https://www.cloud.wispro.co/api/v1/clients/' . $uuid;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data'];
        $custom_id = $datos['custom_id'];
        $name = $datos['name'];
        //   $email = $datos['email'];
        // $id = $datos['id'];
        // $name = $datos['name'];
        //return $datos;
        return [
            'custom_id' => $custom_id,
            'name' => $name,
            //     'email'=>$email
        ]; //()->json($datos, 200);
    }
    public static function obtenerFacturasXCI($id)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=void&client_national_identification_number_eq=12345678
        $token4 = 'https://www.cloud.wispro.co/api/v1/invoicing/invoices?client_national_identification_number_eq=' . $id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        // $datos = $datos['data'];
        // $datos = $datos[0];
        // $id = $datos['id'];
        // $name = $datos['name'];
        return $datos; //()->json($datos, 200);
    }
    public static function cantContratosClientexId($nro_ci)
    {

        //
        //*************funca***************** */
        //https://www.cloud.wispro.co/api/v1/contracts?client_national_identification_number_eq=1234569
        $token4 = 'https://www.cloud.wispro.co/api/v1/contracts?client_national_identification_number_eq=' . $nro_ci;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data']; //()->json($datos, 200);
        $contratosId = [];
        foreach ($datos as $data) {
            $contratosId[] = ['contratoId' => $data['id'], 'plan_id' => $data['plan_id'], 'client_id' => $data['client_id'], 'state' => $data['state']];
        }
        // $datos = $datos['meta'];
        // $datos = $datos['pagination'];
        // $datos = $datos['total_records'];
        // return $datos; //()->json($datos, 200);
        return $contratosId; //()->json($datos, 200);
    }
    public static function obtenerEstadoDelContratosXuuid($uuid)
    {

        //
        //*************funca***************** */
        ini_set('max_execution_time', 36000);
        $token4 = 'https://www.cloud.wispro.co/api/v1/contracts?client_id_eq=' . $uuid;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);

        $datos = $datos['data'];

        $id = $datos[0]['id'];
        $state = $datos[0]['state'];
        $plan_id = $datos[0]['plan_id'];

        if ($datos[0]['latitude'] != null) {

            $latitude = $datos[0]['latitude'];
        } else {
            $latitude = '';
        }
        if ($datos[0]['longitude'] != null) {

            $longitude = $datos[0]['longitude'];
        } else {
            $longitude = '';
        }

        $planPrecio = Helpers::obtenerPlanXContratoId($plan_id);

        return [
            'id' => $id,
            'state' => $state,
            'precio' => $planPrecio,
            'plan_id' => $plan_id,
            'latitude' => $latitude,
            'longitude' => $longitude,
        ];
    }
    public static function obtenerPrecioDelContratoXClientId($uuid)
    {

        //
        //*************funca***************** */

        $token4 = 'https://www.cloud.wispro.co/api/v1/contracts?client_id_eq=' . $uuid;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);

        $datos = $datos['data'];

        $id = $datos[0]['id'];
        $state = $datos[0]['state'];
        $plan_id = $datos[0]['plan_id'];

        $planPrecio = Helpers::obtenerPlanXContratoId($plan_id);

        return $planPrecio;
    }
    public static function obtenerPlanXContratoId($id)
    {

        //
        //*************funca***************** */
        ini_set('max_execution_time', 36000);
        https: //www.cloud.wispro.co/api/v1/plans/5a6f029d-f9cc-44f0-8c5c-f4ff170a3943
        $token4 = 'https://www.cloud.wispro.co/api/v1/plans/' . $id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data']; //()->json($datos, 200);
        //$name = $datos['name']; //()->json($datos, 200);

        $precio = floatval($datos['price']); //()->json($datos, 200);

        // $datos = $datos['meta'];
        // $datos = $datos['pagination'];
        // $datos = $datos['total_records'];
        return $precio; //()->json($datos, 200);
        //return $datos; //()->json($datos, 200);
    }
    public static function obtenerPlanXContratoId2($id)
    {

        //
        //*************funca***************** */
        https: //www.cloud.wispro.co/api/v1/plans/5a6f029d-f9cc-44f0-8c5c-f4ff170a3943
        $token4 = 'https://www.cloud.wispro.co/api/v1/plans/' . $id;
        //dd($token4);
        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->get($token4);

        $datos = json_decode($response, true);
        $datos = $datos['data']; //()->json($datos, 200);
        $name = $datos['name']; //()->json($datos, 200);

        $precio = floatval($datos['price']); //()->json($datos, 200);

        // $datos = $datos['meta'];
        // $datos = $datos['pagination'];
        // $datos = $datos['total_records'];
        return ['precio' => $precio, 'nombre' => $name]; //()->json($datos, 200);
        //return $datos; //()->json($datos, 200);
    }
    public static function tokenAuthBnb()
    {
        //
        // $token4 = 'http://test.bnb.com.bo/ClientAuthentication.API/api/v1/auth/token';
        $token4 = 'https://marketapi.bnb.com.bo/ClientAuthentication.API/api/v1/auth/token';
        $responseAuth = Http::withHeaders([
            // 'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($token4, [
            'accountId' => "A5DKHbX8hlHokokVpkVTpA==",
            'authorizationId' => "y1UZY6u+YqF2eof9HWKTxQ==",
        ]);
        $response_token = json_decode($responseAuth, true);
        return $response_token; //()->json($datos, 200);
    }
    public static function generarQrBnb($token, $gloss, $amount, $singleUse, $expirationDate, $additionalData, $id)
    {
        //
        // $url_base = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync';
        $url_base = 'https://marketapi.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => 'Bearer ' . $token,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url_base, [
            'currency' => 'BOB',
            'gloss' => $gloss,
            'amount' => $amount,
            'singleUse' => $singleUse,
            'expirationDate' => $expirationDate,
            'additionalData' => $additionalData,
            'destinationAccountId' => 1
        ]);
        $response_token = json_decode($responseAuth, true);
        // $response_token = $response_token['qr'];
        if ($response_token['success']) {
            $qr = new Qr();
            $qr->currency = 'BOB';
            $qr->qr_id = $response_token['id'];
            $qr->gloss = $gloss;
            $qr->amount = $amount;
            $qr->expirationDate = $expirationDate;
            $qr->singleUse = $singleUse;
            $qr->additionalData = $additionalData;
            $qr->destinationAccountId = 1;
            $qr->client_id = $id;
            $qr->save();
            return [
                'responseToken' => $response_token,
                'qr_id' => $qr->id
            ]; //['token' => $response_token, 'qr_id' => $qr->id]; //()->json($datos, 200);
        } else {
            return $response_token; //['token' => $response_token, 'qr_id' => $qr->id]; //()->json($datos, 200);

        }
    }
    public static function statusQrBnb($token, $qr_id)
    {
        //
        // $url_base = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync';
        $url_base = 'https://marketapi.bnb.com.bo/QRSimple.API/api/v1/main/getQRStatusAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => 'Bearer ' . $token,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url_base, [

            'qrId' => $qr_id,

        ]);
        $response_token = json_decode($responseAuth, true);
        // $response_token = $response_token['qr'];



        return $response_token; //['token' => $response_token, 'qr_id' => $qr->id]; //()->json($datos, 200);





    }
    public static function eliminarQrBnb($token, $qr_id)
    {
        //
        // $url_base = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/getQRWithImageAsync';
        $url_base = 'https://marketapi.bnb.com.bo/QRSimple.API/api/v1/main/CancelQRByIdAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => 'Bearer ' . $token,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url_base, [

            'qrId' => $qr_id,

        ]);
        $response_token = json_decode($responseAuth, true);
        // $response_token = $response_token['qr'];



        return $response_token; //['token' => $response_token, 'qr_id' => $qr->id]; //()->json($datos, 200);





    }
    public static function pagoRealizado($event)
    {
        Log::channel('pagoQrBnb')->info("************************   " . now() . "   ****************************");
        Log::channel('pagoQrBnb')->info("Registro de pago Por QR::>" . now());

        date_default_timezone_set('America/La_Paz');

        $fechaActual = date('d-m-Y');

        $fechaHoraError = date('d-m-Y h:i:s');
        $fechaLimitePromesaPago = date('10-m-Y');
        // fecha para crear promesa de pago
        $fechaInicioPromesaPago = strtotime($fechaLimitePromesaPago);
        $fechaActu = strtotime($fechaActual);

        DB::beginTransaction();
        try {
            $qrr = Qr::where("qr_id", $event->bnb->QRId)->count();
            if ($qrr > 0) {

                $qrr = Qr::where("qr_id", $event->bnb->QRId)->first();

                $clientID = $qrr->client_id;

                $client = Client::where("id", $clientID)->first();

                $clienteNroCi = $client->national_identification_number;

                $authBnb = Helpers::tokenAuthBnb();

                $success = $authBnb['success'];

                $tokenBnb = $authBnb['message'];

                if ($success) {

                    $statusQrBnb = Helpers::statusQrBnb($tokenBnb, $event->bnb->QRId);

                    $statusId = $statusQrBnb['statusId'];

                    if ($statusId == 1) {

                        $plan = Plan::find(1);

                        $qrr = Qr::where("qr_id", $event->bnb->QRId)->first();

                        $imageQr = ImagenQr::where("qr_id", $qrr->id)->first();

                        $pagoAdelantadoCount = PagoAdelantado::where("imagen_qr_id", $imageQr->id)->where('estado', false)->count();
                        $monto_a_pagar = PagoAdelantado::select('pagoTotal', 'cliente_uuid')->where("imagen_qr_id", $imageQr->id)->where('estado', false)->first();
                        Log::channel('pagoQrBnb')->info("monto_a_pagar::::: " .  $monto_a_pagar);
                        Log::channel('pagoQrBnb')->info("pago adelantado " .  $pagoAdelantadoCount);

                        $facturas = Factura::where("imagen_qr_id", $imageQr->id)->get();
                        $ids = [];
                        if ($pagoAdelantadoCount > 0) {



                            //     $countMesPagado= Mespagado::where
                            $countPagos = PagoAdelantado::where("custom_id", $imageQr->custom_id)->count();
                            Log::channel('pagoQrBnb')->info("countPagos " .  $countPagos);
                            if ($countPagos > 0) {
                                Log::channel('pagoQrBnb')->info("Entro AQUI::::: " .  $countPagos);
                                $pago_adelantado = PagoAdelantado::orderBy('id', 'desc')
                                    ->where("custom_id", $imageQr->custom_id)
                                    ->where("estado", true)
                                    // ->with('mespagados')
                                    ->first();

                                if (isset($pago_adelantado->id)) {

                                    $mesespagadosUltimo = Mespagado::orderBy('id', 'desc')->where('pago_adelantado_id', $pago_adelantado->id)->first();
                                    $ultimo_mes_pagado = $mesespagadosUltimo->meses_pagados;
                                    $clienteUUID = $pago_adelantado->cliente_uuid;
                                }
                                $fechaPeriodo = date('d-m-Y');
                                if (isset($ultimo_mes_pagado)) {
                                    $fechaPeriodo = $ultimo_mes_pagado;
                                }

                                $fechaPago = date('Y-m-d H:i:s');
                                Log::channel('pagoQrBnb')->info("pago fechaPago " .  $fechaPago . " UUUIIDDD " . $monto_a_pagar->cliente_uuid);
                                $comment = 'Pago adelantado con QR en ' . $fechaPago;
                                // pagar wispro
                                $ides = "";

                                $resultInvoice = Helpers::pageInvoice($monto_a_pagar->cliente_uuid, $ides, $monto_a_pagar->pagoTotal, $comment);
                                Log::channel('pagoQrBnb')->info("resultInvoice  " . $resultInvoice);
                                // Log::channel('pagoQrBnb')->info("resultInvoice TTTTT:::  " . $resultInvoice->success);
                                Log::channel('pagoQrBnb')->info("EL cliente pago Bs." . $monto_a_pagar->pagoTotal . " fecha de pago a wispro " . now());

                                $fechaActual2 = date('Y-m-d H:i:s');
                                $cliente_id = Client::select('id')
                                    ->where("id_wispro", $monto_a_pagar->cliente_uuid)
                                    ->first();
                                // Elimnar de la BBDDX
                                Log::channel('pagoQrBnb')->info("despues Pago BD " . $cliente_id);
                                Log::channel('pagoQrBnb')->info("pago_adelantado->pagoTotal " . $monto_a_pagar->pagoTotal);
                                Pago::Create([
                                    'QRId' => $event->bnb->QRId,
                                    'Gloss' => $event->bnb->Gloss,
                                    'sourceBankId' => $event->bnb->sourceBankId,
                                    'originName' => $event->bnb->originName,
                                    'VoucherId' => $event->bnb->VoucherId,
                                    'TransactionDateTime' => $event->bnb->TransactionDateTime,
                                    'additionalData' => $event->bnb->additionalData,

                                    'monto' => $monto_a_pagar->pagoTotal,
                                    //$factura->amount,
                                    //$event->$qrr->amount,
                                    //'numeroFactura' => $factura->numeroFactura,
                                    //$factura->numeroFactura,
                                    //$event->bnb->id,
                                    'client_id' => $cliente_id->id,
                                ]);
                                Log::channel('pagoQrBnb')->info("despues Pago BD " . now());
                                // consultar Saldo wispro

                                Log::channel('pagoQrBnb')->info("EL cliente pago Bs." . $monto_a_pagar->pagoTotal . " fecha de pago a wispro " . now());
                                // $saldo_a_favor_wispro =
                                //     $saldo_cliente =

                                $pagoAdelantado =
                                    PagoAdelantado::where("imagen_qr_id", $imageQr->id)
                                    ->where('estado', false)

                                    ->first();

                                Log::channel('pagoQrBnb')->info("pago fechaPago " .  $pagoAdelantado);
                                $pagoAdelantado->fechaPago = $fechaPago;
                                $pagoAdelantado->saldo_a_favor_wispro = 2036.0; //$saldo_a_favor_wispro;
                                $pagoAdelantado->saldo_cliente = 2036.0; //$saldo_cliente;
                                //   $pagoAdelantado->desc_estado = 'Pago Realizado por adelantado de ' . $pagoAdelantado->cantMes . " meses";
                                $pagoAdelantado->estado = 1;
                                $pagoAdelantado->update();


                                Log::channel('pagoQrBnb')->info("pagoAdelantado->cantMes " .  $pagoAdelantado->cantMes);
                                for ($i = 0; $i < $pagoAdelantado->cantMes; $i++) {
                                    Log::channel('pagoQrBnb')->info("pago fechaPago " .  $i);
                                    $periodo = date("m-Y", strtotime($fechaPeriodo . "+ " . $i + 1 . " month"));
                                    $mes = date("Y-m-d", strtotime($fechaPeriodo . "+ " . $i + 1 . " month"));
                                    $restando = $pagoAdelantado->pagoTotal - $pagoAdelantado->precioPlanBase;
                                    $mespagado = new Mespagado();
                                    $mespagado->monto_debitado = $pagoAdelantado->precioPlanBase;
                                    $mespagado->periodo = $periodo;
                                    // $mespagado->saldo_cliente = 'Pagado';
                                    $mespagado->desc_estado = "Pagado";
                                    $mespagado->codigo_pago = 2;
                                    $mespagado->meses_pagados = $mes;
                                    $mespagado->descripcion = "Pagado por adelantado del periodo " . $periodo;
                                    $mespagado->pago_adelantado_id = $pagoAdelantado->id;
                                    $mespagado->save();
                                    Log::channel('pagoQrBnb')->info("pago fechaPago " .  $mespagado);
                                }
                                $iiii = ImagenQr::where('montoMes', '=', $imageQr->montoMes)
                                    ->where('custom_id', '=', $imageQr->custom_id)
                                    ->where('periodo', '=', $imageQr->periodo)
                                    ->update([
                                        'activo' => 2,
                                        // 'statusId' => $statusId,
                                    ]);

                                $imaqr2 = ImagenQr::find($imageQr->id);
                                $imaqr2->estado = 1; //pagado
                                $imaqr2->statusId = $statusId;
                                $imaqr2->activo = 1; //1= activo muestra 2=Inactivo No muestra
                                $imaqr2->update();


                                //colocando estado a 1 a las facturas que fueron pagadas
                                $fact = Factura::where('imagen_qr_id', '=', $qrr->id)
                                    ->update([
                                        'estado' => 1,
                                    ]);

                                // Log::info('$fact:::' . $fact);
                                $facturasPendientes = Helpers::facturasPendientes($clienteNroCi);
                                $facturasPendientes = $facturasPendientes['meta'];
                                $facturasPendientes = $facturasPendientes['pagination'];
                                $factPendientes = $facturasPendientes['total_records'];
                                // Log::info('$factPendientes:::' . $factPendientes);
                                if ($factPendientes == 0) {
                                    $imaqr = ImagenQr::find($imageQr->id);
                                    $immaaaa = ImagenQr::where('periodo', '=', $imaqr->periodo)
                                        ->where('activo', '!=', 1)
                                        ->update([
                                            'activo' => 2,
                                            // 'statusId' => $statusId,
                                        ]);
                                    // Log::info('$immaaaa::Fin:' . $immaaaa);
                                }
                                Log::channel('pagoQrBnb')->info("********************************FIN PAGO ADELANTADO**************************************************************");
                                DB::commit();
                            }
                        } else if (count($facturas) > 0) {

                            foreach ($facturas as $factura) {

                                $monto = 0;
                                $ids = [];
                                $pagosWispros = PagoWispro::select('id_invoice', 'amount', 'cliente_uuid')->where("factura_id", $factura->id)->get()->all();
                                $cont = count($pagosWispros);
                                foreach ($pagosWispros as $pagosWis) {
                                    $client_id = $pagosWis->cliente_uuid;
                                    $monto = $monto + floatval($pagosWis->amount);
                                    $ids[] = $pagosWis->id_invoice;
                                }
                                // $invoice[] = [$ids, $client_id, $monto];
                                $comment = 'Pago por QR en ' . $fechaActual;
                                $estadoYprecio = Helpers::obtenerEstadoDelContratosXuuid($client_id);
                                Log::channel('pagoQrBnb')->info("antes del pageInvoice " . now());
                                $estadoContrato = Helpers::pageInvoice($client_id, $ids, $monto, $comment);
                                $fechaActual2 = date('Y-m-d H:i:s');
                                Log::channel('pagoQrBnb')->info("EL cliente pago Bs." . $monto . " fecha de pago a wispro " . now());

                                // Elimnar de la BBDDX
                                Pago::Create([
                                    'QRId' => $event->bnb->QRId,
                                    'Gloss' => $event->bnb->Gloss,
                                    'sourceBankId' => $event->bnb->sourceBankId,
                                    'originName' => $event->bnb->originName,
                                    'VoucherId' => $event->bnb->VoucherId,
                                    'TransactionDateTime' => $event->bnb->TransactionDateTime,
                                    'additionalData' => $event->bnb->additionalData,
                                    'monto' => $factura->amount,
                                    //$factura->amount,
                                    //$event->$qrr->amount,
                                    'numeroFactura' => $factura->numeroFactura,
                                    //$factura->numeroFactura,
                                    //$event->bnb->id,
                                    'client_id' => $factura->client_id //$event->bnb->id,
                                ]);
                                Log::channel('pagoQrBnb')->info("despues Pago BD " . now());

                                if ($estadoYprecio['precio'] > $plan->precio) {
                                    $resHab =  Helpers::habilitar_cattv($factura->custom_id);
                                    Log::channel('pagoQrBnb')->info("Plan:: " . $estadoYprecio['precio'] . " Y se habilitado CATV a esta hora::> " . now() . " respuestaHabilitar::>" . $resHab);

                                    if ($estadoYprecio['state'] == "disabled") {
                                        Log::channel('pagoQrBnb')->info("El estado de este cliente esta en ::> " . $estadoYprecio['state'] . "  en CATV ");
                                        $resReboot = Helpers::rebootSmart($factura->custom_id);
                                        Log::channel('pagoQrBnb')->info("Se reinicio CATV a esta hora::> " . now() . " por que estaba en un estado::> " . $estadoYprecio['state'] . "  respuestaReinicio::>" . $resReboot);
                                    } else {

                                        Log::channel('pagoQrBnb')->info("El estado de este cliente esta en ::> " . $estadoYprecio['state'] . " por eso no se reinicio en CATV " . " respuestaHabilitar::>" . $resHab);
                                    }
                                    // eliminar BD Wisprocron 23913a7f-82fa-41a5-ac47-a8b466bd2cbe
                                    $resultWiscron = Wisprocron::select('id')->where('custom_id', $factura->custom_id)->count();
                                    Log::channel('pagoQrBnb')->info("contador " . $resultWiscron);
                                    if ($resultWiscron > 0) {
                                        $resultWiscron = Wisprocron::where('custom_id', $factura->custom_id)->first();

                                        $periodo = date('Y-m-d');
                                        $lista = new ListaNegra();
                                        $lista->custom_id = $resultWiscron->custom_id;
                                        $lista->name = $resultWiscron->name;
                                        $lista->precio = $resultWiscron->precio;
                                        $lista->contrato_id = $resultWiscron->contrato_id;
                                        $lista->plan_id = $resultWiscron->plan_id;
                                        $lista->client_id = $resultWiscron->client_id;
                                        //$lista->state_contrato = $resultWiscron->state;
                                        $lista->pasarela = "Pago realizado por Sintesis";
                                        $lista->periodo = $periodo;
                                        $lista->estado = true;
                                        $lista->hora_activar_smart = $fechaActual2;
                                        // $lista->estado_smart = $resultWiscron->;
                                        // $lista->descripcion =$resultWiscron->;
                                        $lista->save();
                                        Log::channel('pagoQrBnb')->info("Cliente registrado en la lista::> " . $factura->custom_id . " se registro:> " . now());
                                        $idDelete = Wisprocron::find($resultWiscron->id);
                                        $idDelete->delete();
                                        Log::channel('pagoQrBnb')->info("El cliente con el codigo::> " . $factura->custom_id . " se elimino de la lista negra a esta hora::> " . now());
                                    } else {
                                        Log::channel('pagoQrBnb')->info("El cliente con el codigo::> " . $factura->custom_id . " No esta registrado en la lista negra " . now());
                                    }
                                }

                                // crea promesa de pago
                                if (isset($factura->numeroFactura)) {
                                    // para generar la promesa de pago
                                    if ($fechaActu > $fechaInicioPromesaPago) {
                                        // crear promesa de pago
                                        $response_token = Helpers::crearPromesasPago($estadoYprecio['id']); //$uuidContrato);
                                        Log::channel('pagoQrBnb')->info("El cliente con el codigo::> " . $factura->custom_id . " se creo una promesa en pago para esta fecha::> " . now());
                                    }
                                }


                                // eliminamos de la BBDD

                                //array_push($invoice_ids2, $pagosWispros);
                            }
                            //Actualizamos tabla ImageQR              
                            // $imaqr = ImagenQr::find($imageQr->id);
                            // $imaqr = ImagenQr::where('', '=', $imageQr->id)->get();
                            //   $imaqr = ImagenQr::all();
                            // Log::info('$imageQr->montoMes:::' . $imageQr->montoMes);
                            // $imaqr = ImagenQr::where('custom_id'$imageQr->id);
                            $iiii = ImagenQr::where('montoMes', '=', $imageQr->montoMes)
                                ->where('custom_id', '=', $imageQr->custom_id)
                                ->where('periodo', '=', $imageQr->periodo)
                                ->update([
                                    'activo' => 2,
                                    // 'statusId' => $statusId,
                                ]);

                            $imaqr2 = ImagenQr::find($imageQr->id);
                            $imaqr2->estado = 1; //pagado
                            $imaqr2->statusId = $statusId;
                            $imaqr2->activo = 1; //1= activo muestra 2=Inactivo No muestra
                            $imaqr2->update();


                            //colocando estado a 1 a las facturas que fueron pagadas
                            $fact = Factura::where('imagen_qr_id', '=', $qrr->id)
                                ->update([
                                    'estado' => 1,
                                ]);

                            // Log::info('$fact:::' . $fact);
                            $facturasPendientes = Helpers::facturasPendientes($clienteNroCi);
                            $facturasPendientes = $facturasPendientes['meta'];
                            $facturasPendientes = $facturasPendientes['pagination'];
                            $factPendientes = $facturasPendientes['total_records'];
                            // Log::info('$factPendientes:::' . $factPendientes);
                            if ($factPendientes == 0) {
                                $imaqr = ImagenQr::find($imageQr->id);
                                $immaaaa = ImagenQr::where('periodo', '=', $imaqr->periodo)
                                    ->where('activo', '!=', 1)
                                    ->update([
                                        'activo' => 2,
                                        // 'statusId' => $statusId,
                                    ]);
                                // Log::info('$immaaaa::Fin:' . $immaaaa);
                            }
                            //Actualizacion tabla facturas
                            // $factura = Factura::find($imaqr->id);
                            // $factura->estado = 1;
                            // $factura->update();


                        }
                    } else {
                        Log::channel('pagoQrBnb')->error('Error con el QrId: ' . $qrr->id . ' al registrar el pago el estado del QR es: ' . $statusId . ' con el siguiente mensaje::> ' . $statusQrBnb['message']);
                        //TODO registrar el evento por que no se pago
                        $imageQr = ImagenQr::find($qrr->id);

                        $imageQr->statusId = $statusId;
                        $imageQr->mensaje = $statusQrBnb['message'];
                        $imageQr->update();
                    }
                    Log::channel('pagoQrBnb')->info("**********************************************************************************************");
                    DB::commit();
                } else {
                    Log::channel('pagoQrBnb')->error('Error al solicitar el token al Banco para realizar el pago success:: ' . $success . ' mensaje:: ' . $tokenBnb);
                    Log::channel('pagoQrBnb')->error("*************************************************************************************************");
                    return 'error';
                }
            }
        } catch (\Exception $e) {
            Log::channel('pagoQrBnb')->error('Error en el DB:transaction ::>' . $e);
            DB::rollBack();
            $errorQr = new ErrorQr();
            $errorQr->qrid = $event->bnb->QRId;
            $errorQr->originName = $event->bnb->originName;
            $errorQr->error = $e;
            $errorQr->TransactionDateTime = $fechaHoraError;
            $errorQr->save();
            return response()->json([
                "success" => false,

                "message" => "Error al registrar el Pago del QR. en el sistema" . $e
            ], 422);
        }
    }
    public static function pagoRealizadoPorSintesis($event)
    {

        // Log::channel('sintesis')->info('Se enviaron :::' . count($dataClientes) . ' :::::::::::>' . $cont);
        date_default_timezone_set('America/La_Paz');

        Log::channel('pagoSintesis')->info("**************************" . now() . "**********************");
        Log::channel('pagoSintesis')->info("Pago realizado por Sintesis Fecha y hora: " . now());
        try {
            // $cus = '210612';31
            // $cus = '210238';32
            // $cus = '211662';33
            // $cus = '210290';34
            $plan = Plan::find(1);
            $sint = Sintesi::where("codigoRecaudacion", $event->pagoSintesis->codigoRecaudacion)->first();
            //$facturasPendientes = Helpers::facturasPendientesPorCustomID($sint->codigoComprador);
            //$cus = '200044';
            $facturasPendientes = Helpers::facturasPendientesPorCustomID($sint->codigoComprador);
            $clienuuid = Helpers::obtenerClienteUUId($sint->codigoComprador);
            $meta = $facturasPendientes['meta'];
            $datas = $facturasPendientes['data'];

            $pagination = $meta['pagination'];
            $total_records = $pagination['total_records'];
            $cont = 0;
            $fechaActual = date('d-m-Y');
            $fechaHoraError = date('d-m-Y h:i:s');
            $fechaLimitePromesaPago = date('10-m-Y');
            // fecha para crear promesa de pago
            $fechaInicioPromesaPago = strtotime($fechaLimitePromesaPago);
            $fechaActu = strtotime($fechaActual);
            $ids_facturas = [];
            $monto_facturas = 0;

            foreach ($datas as $data) {
                $cont++;
                $items = $data['items'];
                foreach ($items as $item) {
                    $monto_facturas = $monto_facturas + floatval($item['amount']);
                    $ids_facturas[] = $item['invoice_id'];
                }
            }
            $comment = 'PagosNet Servicio  ' . $fechaActual;

            $estadoYprecio = Helpers::obtenerEstadoDelContratosXuuid($clienuuid);
            $pagarFactura = Helpers::pageInvoiceSintesis($clienuuid, $ids_facturas, $monto_facturas, $comment);


            if ($estadoYprecio['precio'] > $plan->precio) {
                $resHabiSintesis = Helpers::habilitar_cattv($sint->codigoComprador);
                Log::channel('pagoSintesis')->info("Plan:: " . $estadoYprecio['precio'] . " Y se habilitado CATV a esta hora::> " . now() . " respuestaHabilitar::>" . $resHabiSintesis);
                if ($estadoYprecio['state'] == "disabled") {
                    Log::channel('pagoSintesis')->info("El estado de este cliente esta en ::> " . $estadoYprecio['state'] . "  en CATV ");
                    $resReboot = Helpers::rebootSmart($sint->codigoComprador);

                    Log::channel('pagoSintesis')->info("Se reinicio CATV a esta hora::> " . now() . " por que estaba en un estado::> " . $estadoYprecio['state'] . "  respuestaReinicio::>" . $resReboot);
                } else {

                    Log::channel('pagoSintesis')->info("El estado de este cliente esta en ::> " . $estadoYprecio['state'] . " por eso no se reinicio en CATV " . " respuestaHabilitar::>" . $resHabiSintesis);
                }

                // Helpers::deshabilitar_cattv($cus);
                // eliminar BD Wisprocron 23913a7f-82fa-41a5-ac47-a8b466bd2cbe
                $resultWiscron = Wisprocron::select('id')->where('custom_id', $sint->codigoComprador)->count();
                Log::channel('pagoSintesis')->info("contador " . $resultWiscron);
                if ($resultWiscron > 0) {
                    $resultWiscron = Wisprocron::where('custom_id', $sint->codigoComprador)->first();
                    $periodo = date('Y-m-d');
                    $lista = new ListaNegra();
                    $lista->custom_id = $resultWiscron->custom_id;
                    $lista->name = $resultWiscron->name;
                    $lista->precio = $resultWiscron->precio;
                    $lista->contrato_id = $resultWiscron->contrato_id;
                    $lista->plan_id = $resultWiscron->plan_id;
                    $lista->client_id = $resultWiscron->client_id;
                    //$lista->state_contrato = $resultWiscron->state;
                    $lista->pasarela = "Pago realizado por Sintesis";
                    $lista->periodo = $periodo;
                    $lista->estado = true;
                    $lista->hora_activar_smart = $fechaActual;
                    // $lista->estado_smart = $resultWiscron->;
                    // $lista->descripcion =$resultWiscron->;
                    $lista->save();
                    Log::channel('pagoSintesis')->info("Cliente registrado en la lista::> " . $sint->custom_id . " se registro:> " . now());
                    $idDelete = Wisprocron::find($resultWiscron->id);
                    $idDelete->delete();

                    Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $sint->codigoComprador . " se elimino de la lista negra a esta hora::> " . now());
                } else {
                    Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $sint->codigoComprador . " No esta registrado en la lista negra " . now());
                }
            }

            // crea promesa de pago

            // para generar la promesa de pago

            $response_token = false;
            if ($fechaActu > $fechaInicioPromesaPago) {
                // crear promesa de pago
                $response_token = Helpers::crearPromesasPago($estadoYprecio['id']); //$uuidContrato);
                Log::channel('pagoSintesis')->info("El cliente con el codigo::> " . $sint->codigoComprador . " se creo una promesa de pago en esta fecha::> " . now());
            }
            $pago_detalle = new PagoDetalle();
            $pago_detalle->nombreComprador = $sint->nombreComprador;
            $pago_detalle->codigoRecaudacion = $sint->codigoRecaudacion;
            $pago_detalle->documentoIdentidadComprador = $sint->documentoIdentidadComprador;
            $pago_detalle->codigoComprador = $sint->codigoComprador;
            $pago_detalle->descripcionRecaudacion = $sint->descripcionRecaudacion;
            $pago_detalle->montoPago = $sint->montoPago;
            $pago_detalle->idTransaccion = $sint->idTransaccion;
            $pago_detalle->codigoError = $sint->codigoError;
            $pago_detalle->descripcionError = $sint->descripcionError;
            $pago_detalle->codigoErrorItem = $sint->codigoErrorItem;
            $pago_detalle->descripcionErrorItem = $sint->descripcionErrorItem;

            $pago_detalle->transaccion = $event->pagoSintesis->transaccion;
            $pago_detalle->fechaPagoSintesis = $event->pagoSintesis->fecha;
            $pago_detalle->horaPagoSintesis = $event->pagoSintesis->hora;
            $pago_detalle->montoPagoSintesis = $event->pagoSintesis->monto;
            $pago_detalle->nroRentaReciboSintesis = $event->pagoSintesis->nroRentaRecibo;

            $pago_detalle->save();
            Log::channel('pagoSintesis')->info("pago detalle registrado: " . $pago_detalle);
            Log::channel('pagoSintesis')->info("*************************************************************************************************");
        } catch (\Exception $e) {
            Log::channel('pagoSintesis')->error('Error al registrar el pago:::' . $event->pagoSintesis->codigoRecaudacion . ' error:' . $e);
            Log::channel('pagoSintesis')->error("*************************************************************************************************");
        }
    }
    public static function eliminarImageQrs($id) {}

    public static function obtenerPlanWispro($id)
    {
        //https://www.cloud.wispro.co/api/v1/contracts?client_id_eq=b8312792-6247-4331-b062-f54b89aa62f1

        $url_base = 'https://www.cloud.wispro.co/api/v1/contracts?client_id_eq=' . $id; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        //$datos = json_decode($response, true);
        $contrato = json_decode($response, true);
        $contrato = $contrato['data'];
        $plan_id = $contrato[0];
        $plan_id = $plan_id['plan_id'];
        return $plan_id;
        // return response()->json($datos, 200);
    }
    public static function crearPromesasPago($uuid)
    {
        //uuid=idContrato

        $url_base = 'https://www.cloud.wispro.co/api/v1/contracts/' . $uuid . '/payment_promises'; //$request->token;

        date_default_timezone_set('America/La_Paz');
        $expirationDate = date('Y-m-d H:i:s');
        $expirationDate = date("Y-m-d H:i:s", strtotime($expirationDate . "+ 1 months - 1 days"));
        $datetime = new DateTime($expirationDate, new DateTimeZone('America/La_Paz'));
        $datetime_promesa = $datetime->format(DateTime::ATOM);

        $responsePago = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'accept' => 'application/json',

        ])->post($url_base, [
            'valid_until' => $datetime_promesa,
        ]);
        if ($responsePago['status'] == 200) {
            return true;
            // return $responsePago;
        }
        return false;
    }
    public static function obtenerPlan($id)
    {

        //https://www.cloud.wispro.co/api/v1/plans/49437e8b-f2da-46df-9c43-4663296c82f0
        $url_base = 'https://www.cloud.wispro.co/api/v1/plans/' . $id; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        //$datos = json_decode($response, true);
        $plan2 = json_decode($response, true);
        $plan2 = $plan2['data'];
        return $plan2;
        // return response()->json($datos, 200);
    }
    public static function verificarFacturas($id)
    {

        //https://www.cloud.wispro.co/api/v1/plans/49437e8b-f2da-46df-9c43-4663296c82f0
        $url_base = 'https://www.cloud.wispro.co/api/v1/invoicing/invoices?state_eq=pending&client_national_identification_number_eq=' . $id; //$request->token;

        //dd($token4);

        $response = Http::withHeaders([
            'Authorization' => '2ee412bd-ffa8-4f84-8c42-4d0a005eac12',
            'Accept' => 'application/json',

        ])->get($url_base);
        // ])->get('https://www.cloud.wispro.co/api/v1/clients' . $request->token);

        //$datos = json_decode($response, true);
        $plan2 = json_decode($response, true);
        //$plan2 = $plan2['data'];
        return $plan2;
        // return response()->json($datos, 200);
    }
    public static function validarEmail($email)
    {

        return (!preg_match("/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix", $email)) ? FALSE : TRUE;
    }
    public static function obtenerMesActual()
    {
        date_default_timezone_set('America/La_Paz');
        $mes = date('m');

        switch ($mes) {
            case '01':
                return $mes2 = 'Enero';

            case '02':
                return $mes2 = 'Febrero';

            case '03':
                return $mes2 = 'Marzo';

            case '04':
                return $mes2 = 'Abril';

            case '05':
                return $mes2 = 'Mayo';

            case '06':
                return $mes2 = 'Junio';

            case '07':
                return $mes2 = 'Julio';

            case '08':
                return $mes2 = 'Agosto';

            case '09':
                return $mes2 = 'Septiembre';

            case '10':
                return $mes2 = 'Octubre';
                // break;
            case '11':
                return $mes2 = 'Noviembre';

            case '12':
                return $mes2 = 'Diciembre';

            default:
                return $mes2 = '';
        }
    }

    public static function registraAlta(
        $id,
        $correoElectronico,
        $documentoIdentidadComprador,
        $nombreComprador,
        $codigoComprador,
        $montoCreditoFiscal, //Double
        $montoPago, //Double
        $nitFactura,
        $nombreFactura,
        $codigoRecaudacion
    ) {

        $fecha_anual = date('Y');
        $fecha_mes = date('m');
        $fecha_dia = date('d');
        $fecha = $fecha_anual . $fecha_mes . $fecha_dia;
        $hora_ho  = date('H');
        $hora_min  = date('i');
        $hora  = $hora_ho . $hora_min;
        //1947=19:47
        $categoriaProducto = 1; //Integer// Como es efectivo boliviano siempre es 1
        // $codigoComprador = '200020'; // codigo que se genera puede ser IDUsuario puede repetirse con el codigo de recaudacion
        //    $codigoRecaudacion = $id; //String//es unico por cada registro no se puede volver a repetir 15 carcateres alfanumerico
        $codigoRecaudacion = $codigoRecaudacion . $fecha_anual . $fecha_mes;
        $mes = Helpers::obtenerMesActual($fecha_mes);

        $descripcionRecaudacion = 'Enlace de Fibra Optica por servicio de comunicación mes de ' . $mes;
        $fechaVencimiento = 0; //
        $horaVencimiento = 0;
        $moneda = 'BS';
        //Planilla
        $descripcion = 'Enlace de Fibra Optica por servicio de comunicación mes de ' . $mes;
        // $nitFactura = '1234569'; // como no hay factura numero de recibo
        $numeroPago = 1; //Integer// numero de pagos Ejemplo 3 tendria que haber 3 planillas  en planilla 1 numeroPago seria: numeroPago=1, planilla 2 numeroPago=2, planilla 3 numeroPago=3, etc 
        $precedenciaCobro = 'N'; //S precedencia primero uno luego el otro N se puede pagar cualcquira T se paga tosos si o si
        $transaccion = 'A'; // Crea un pago B= crea una baja con los mimos datos solo cambia aqui

        // Guardamos en la BD
        // validar
        // $request->validate([
        //     "name" => "required",
        //     "email" => "required|email|unique:users",
        //     "password" => "required|string|min:6"
        // ]);



        // guardar como objeto
        $new_sintesis = new Sintesi();

        $new_sintesis->transaccion = $transaccion;
        $new_sintesis->nombreComprador = $nombreComprador;
        $new_sintesis->documentoIdentidadComprador = $documentoIdentidadComprador;
        $new_sintesis->codigoComprador = $codigoComprador;
        $new_sintesis->fecha = $fecha;
        $new_sintesis->hora = $hora;
        $new_sintesis->correoElectronico = $correoElectronico;
        $new_sintesis->moneda = $moneda;



        $new_sintesis->descripcionRecaudacion = $descripcionRecaudacion;
        // $new_sintesis->fechaVencimiento = $fechaVencimiento;
        // $new_sintesis->horaVencimiento = $horaVencimiento;

        // $new_sintesis->numeroPago = $numeroPago;
        $new_sintesis->montoPago = $montoPago;
        $new_sintesis->descripcion = $descripcion;
        $new_sintesis->montoCreditoFiscal = $montoCreditoFiscal;
        $new_sintesis->nombreFactura = $nombreFactura;
        $new_sintesis->nitFactura = $nitFactura;
        $new_sintesis->codigoRecaudacion = $codigoRecaudacion;
        $new_sintesis->save();

        //return $rec->cod_recaudacion;

        // $cuenta = 'wsboldatasat'; //TEST
        // $pass = 'WsBOLDATASAT21'; //TEST
        $cuenta = 'wsboldatasat';
        $pass = 'Boldat2024';
        $xml_envio = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://servicios.comelec.ws.sintesis.com.bo/">
		<soapenv:Header/>
		<soapenv:Body>
		<ser:registroPlan>
			
			<datos>
			
				<categoriaProducto>' . $categoriaProducto . '</categoriaProducto>
			
				<codigoComprador>' . $codigoComprador . '</codigoComprador>
			
				<codigoRecaudacion>' . $codigoRecaudacion . '</codigoRecaudacion>
			
				<correoElectronico>' . $correoElectronico . '</correoElectronico>
			
				<descripcionRecaudacion>' . $descripcionRecaudacion . '</descripcionRecaudacion>
			
				<documentoIdentidadComprador>' . $documentoIdentidadComprador . '</documentoIdentidadComprador>
			
				<fecha>' . $fecha . '</fecha>
			
				<fechaVencimiento>' . $fechaVencimiento . '</fechaVencimiento>
			
				<hora>' . $hora . '</hora>
			
				<horaVencimiento>' . $horaVencimiento . '</horaVencimiento>
			
				<moneda>' . $moneda . '</moneda>
			
				<nombreComprador>' . $nombreComprador . '</nombreComprador>
			
				<planillas>
			
					<descripcion>' . $descripcion . '</descripcion>
			
					<montoCreditoFiscal>' . $montoCreditoFiscal . '</montoCreditoFiscal>
			
					<montoPago>' . $montoPago . '</montoPago>
			
					<nitFactura>' . $nitFactura . '</nitFactura>
			
					<nombreFactura>' . $nombreFactura . '</nombreFactura>
			
					<numeroPago>' . $numeroPago . '</numeroPago>
				</planillas>
			
				<precedenciaCobro>' . $precedenciaCobro . '</precedenciaCobro>
			
				<transaccion>' . $transaccion . '</transaccion>
			</datos>
			
			<cuenta>' . $cuenta . '</cuenta>
			
			<password>' . $pass . '</password>
		</ser:registroPlan>
		</soapenv:Body>
		</soapenv:Envelope>';

        //PASO 05
        //ENVÍO DEL CPE A WS DE SUNAT

        //$ws = "http://test.sintesis.com.bo:80/WSApp-war/ComelecWS"; //test
        $ws = "https://web.sintesis.com.bo:443/WSApp-war/ComelecWS"; //produccion
        $header = array(
            "Content-type: text/xml; charset=\"utf-8\"",
            "Accept: text/xml",
            "Cache-Control: no-cache",
            "Pragma: no-cache",
            "SOAPAction: "

        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
        curl_setopt($ch, CURLOPT_URL, $ws);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_envio);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        // curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__)."/cacert.pem");
        $response = curl_exec($ch);
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $doc = new DOMDocument();
        $doc->loadXML($response);
        if (isset($doc->getElementsByTagName('codigoError')->item(0)->nodeValue)) {
            $codigoError = $doc->getElementsByTagName('codigoError')->item(0)->nodeValue;
            $descripcionError = $doc->getElementsByTagName('descripcionError')->item(0)->nodeValue;

            if ($codigoError == 0) {
                $idTransaccion = $doc->getElementsByTagName('idTransaccion')->item(0)->nodeValue;

                // $new_sintesis->id;

                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError,
                    'idTransaccion' => $idTransaccion,
                    'id' => $new_sintesis->id,
                ];
            } else {

                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError,
                    'id' => $new_sintesis->id,

                ];
            }
        } else {
            return 'error';
        }
    }
    public static function registroUpdate(

        $correoElectronico,
        $documentoIdentidadComprador,
        $nombreComprador,
        $codigoComprador,
        $montoCreditoFiscal, //Double
        $montoPago, //Double
        $nitFactura,
        $nombreFactura,
        $codigoRecaudacion
    ) {

        $fecha_anual = date('Y');
        $fecha_mes = date('m');
        $fecha_dia = date('d');
        $fecha = $fecha_anual . $fecha_mes . $fecha_dia;
        $hora_ho  = date('H');
        $hora_min  = date('i');
        $hora  = $hora_ho . $hora_min;
        //1947=19:47
        $categoriaProducto = 1; //Integer// Como es efectivo boliviano siempre es 1
        // $codigoComprador = '200020'; // codigo que se genera puede ser IDUsuario puede repetirse con el codigo de recaudacion
        //    $codigoRecaudacion = $id; //String//es unico por cada registro no se puede volver a repetir 15 carcateres alfanumerico
        $mes = Helpers::obtenerMesActual();

        $descripcionRecaudacion = 'Enlace de Fibra Optica por servicio de comunicación mes de ' . $mes;
        $fechaVencimiento = 0; //
        $horaVencimiento = 0;
        $moneda = 'BS';
        //Planilla
        $descripcion = 'Enlace de Fibra Optica por servicio de comunicación mes de ' . $mes;
        // $nitFactura = '1234569'; // como no hay factura numero de recibo
        $numeroPago = 1; //Integer// numero de pagos Ejemplo 3 tendria que haber 3 planillas  en planilla 1 numeroPago seria: numeroPago=1, planilla 2 numeroPago=2, planilla 3 numeroPago=3, etc 
        $precedenciaCobro = 'N'; //S precedencia primero uno luego el otro N se puede pagar cualcquira T se paga tosos si o si
        $transaccion = 'A'; // Crea un pago B= crea una baja con los mimos datos solo cambia aqui

        // Guardamos en la BD
        // validar
        // $request->validate([
        //     "name" => "required",
        //     "email" => "required|email|unique:users",
        //     "password" => "required|string|min:6"
        // ]);



        // guardar como objeto



        //return $rec->cod_recaudacion;

        // $cuenta = 'wsboldatasat'; //TEST
        // $pass = 'WsBOLDATASAT21'; //TEST
        $cuenta = 'wsboldatasat';
        $pass = 'Boldat2024';
        $xml_envio = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://servicios.comelec.ws.sintesis.com.bo/">
		<soapenv:Header/>
		<soapenv:Body>
		<ser:registroPlan>
			
			<datos>
			
				<categoriaProducto>' . $categoriaProducto . '</categoriaProducto>
			
				<codigoComprador>' . $codigoComprador . '</codigoComprador>
			
				<codigoRecaudacion>' . $codigoRecaudacion . '</codigoRecaudacion>
			
				<correoElectronico>' . $correoElectronico . '</correoElectronico>
			
				<descripcionRecaudacion>' . $descripcionRecaudacion . '</descripcionRecaudacion>
			
				<documentoIdentidadComprador>' . $documentoIdentidadComprador . '</documentoIdentidadComprador>
			
				<fecha>' . $fecha . '</fecha>
			
				<fechaVencimiento>' . $fechaVencimiento . '</fechaVencimiento>
			
				<hora>' . $hora . '</hora>
			
				<horaVencimiento>' . $horaVencimiento . '</horaVencimiento>
			
				<moneda>' . $moneda . '</moneda>
			
				<nombreComprador>' . $nombreComprador . '</nombreComprador>
			
				<planillas>
			
					<descripcion>' . $descripcion . '</descripcion>
			
					<montoCreditoFiscal>' . $montoCreditoFiscal . '</montoCreditoFiscal>
			
					<montoPago>' . $montoPago . '</montoPago>
			
					<nitFactura>' . $nitFactura . '</nitFactura>
			
					<nombreFactura>' . $nombreFactura . '</nombreFactura>
			
					<numeroPago>' . $numeroPago . '</numeroPago>
				</planillas>
			
				<precedenciaCobro>' . $precedenciaCobro . '</precedenciaCobro>
			
				<transaccion>' . $transaccion . '</transaccion>
			</datos>
			
			<cuenta>' . $cuenta . '</cuenta>
			
			<password>' . $pass . '</password>
		</ser:registroPlan>
		</soapenv:Body>
		</soapenv:Envelope>';

        //PASO 05
        //ENVÍO DEL CPE A WS DE SUNAT

        //$ws = "http://test.sintesis.com.bo:80/WSApp-war/ComelecWS"; //test
        $ws = "https://web.sintesis.com.bo:443/WSApp-war/ComelecWS"; //produccion
        $header = array(
            "Content-type: text/xml; charset=\"utf-8\"",
            "Accept: text/xml",
            "Cache-Control: no-cache",
            "Pragma: no-cache",
            "SOAPAction: "

        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
        curl_setopt($ch, CURLOPT_URL, $ws);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_envio);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        // curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__)."/cacert.pem");
        $response = curl_exec($ch);
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $doc = new DOMDocument();
        $doc->loadXML($response);
        if (isset($doc->getElementsByTagName('codigoError')->item(0)->nodeValue)) {
            $codigoError = $doc->getElementsByTagName('codigoError')->item(0)->nodeValue;
            $descripcionError = $doc->getElementsByTagName('descripcionError')->item(0)->nodeValue;

            if ($codigoError == 0) {
                $idTransaccion = $doc->getElementsByTagName('idTransaccion')->item(0)->nodeValue;


                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError,
                    'idTransaccion' => $idTransaccion,
                    //  'id' => $new_sintesis->id,
                ];
            } else {

                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError,
                    // 'id' => $new_sintesis->id,

                ];
            }
        } else {
            return 'error';
        }
    }
    public static function registraBaja(

        $correoElectronico,
        $documentoIdentidadComprador,
        $nombreComprador,
        $codigoComprador,
        $montoCreditoFiscal, //Double
        $montoPago, //Double
        $nitFactura,
        $nombreFactura,
        $codigoRecaudacion
    ) {


        $fecha_anual = date('Y');
        $fecha_mes = date('m');
        $fecha_dia = date('d');
        $fecha = $fecha_anual . $fecha_mes . $fecha_dia;
        $hora_ho  = date('H');
        $hora_min  = date('i');
        $hora  = $hora_ho . $hora_min;
        //1947=19:47
        $categoriaProducto = 1; //Integer// Como es efectivo boliviano siempre es 1
        // $codigoComprador = '200020'; // codigo que se genera puede ser IDUsuario puede repetirse con el codigo de recaudacion
        //    $codigoRecaudacion = $id; //String//es unico por cada registro no se puede volver a repetir 15 carcateres alfanumerico
        $mes = Helpers::obtenerMesActual();


        $descripcionRecaudacion = 'Servicio Internet mes de ' . $mes;
        $fechaVencimiento = 0; //
        $horaVencimiento = 0;
        $moneda = 'BS';
        //Planilla
        $descripcion = 'Servicio Internet mes de ' . $mes;
        // $nitFactura = '1234569'; // como no hay factura numero de recibo
        $numeroPago = 1; //Integer// numero de pagos Ejemplo 3 tendria que haber 3 planillas  en planilla 1 numeroPago seria: numeroPago=1, planilla 2 numeroPago=2, planilla 3 numeroPago=3, etc 
        $precedenciaCobro = 'N'; //S precedencia primero uno luego el otro N se puede pagar cualcquira T se paga tosos si o si
        $transaccion = 'B'; // Crea un pago B= crea una baja con los mimos datos solo cambia aqui







        //return $rec->cod_recaudacion;

        // $cuenta = 'wsboldatasat'; //TEST
        // $pass = 'WsBOLDATASAT21'; //TEST
        $cuenta = 'wsboldatasat';
        $pass = 'Boldat2024';
        $xml_envio = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://servicios.comelec.ws.sintesis.com.bo/">
		<soapenv:Header/>
		<soapenv:Body>
		<ser:registroPlan>
			
			<datos>
			
				<categoriaProducto>' . $categoriaProducto . '</categoriaProducto>
			
				<codigoComprador>' . $codigoComprador . '</codigoComprador>
			
				<codigoRecaudacion>' . $codigoRecaudacion . '</codigoRecaudacion>
			
				<correoElectronico>' . $correoElectronico . '</correoElectronico>
			
				<descripcionRecaudacion>' . $descripcionRecaudacion . '</descripcionRecaudacion>
			
				<documentoIdentidadComprador>' . $documentoIdentidadComprador . '</documentoIdentidadComprador>
			
				<fecha>' . $fecha . '</fecha>
			
				<fechaVencimiento>' . $fechaVencimiento . '</fechaVencimiento>
			
				<hora>' . $hora . '</hora>
			
				<horaVencimiento>' . $horaVencimiento . '</horaVencimiento>
			
				<moneda>' . $moneda . '</moneda>
			
				<nombreComprador>' . $nombreComprador . '</nombreComprador>
			
				<planillas>
			
					<descripcion>' . $descripcion . '</descripcion>
			
					<montoCreditoFiscal>' . $montoCreditoFiscal . '</montoCreditoFiscal>
			
					<montoPago>' . $montoPago . '</montoPago>
			
					<nitFactura>' . $nitFactura . '</nitFactura>
			
					<nombreFactura>' . $nombreFactura . '</nombreFactura>
			
					<numeroPago>' . $numeroPago . '</numeroPago>
				</planillas>
			
				<precedenciaCobro>' . $precedenciaCobro . '</precedenciaCobro>
			
				<transaccion>' . $transaccion . '</transaccion>
			</datos>
			
			<cuenta>' . $cuenta . '</cuenta>
			
			<password>' . $pass . '</password>
		</ser:registroPlan>
		</soapenv:Body>
		</soapenv:Envelope>';

        //PASO 05
        //ENVÍO DEL CPE A WS DE SUNAT

        //$ws = "http://test.sintesis.com.bo:80/WSApp-war/ComelecWS"; //test
        $ws = "https://web.sintesis.com.bo:443/WSApp-war/ComelecWS"; //produccion
        $header = array(
            "Content-type: text/xml; charset=\"utf-8\"",
            "Accept: text/xml",
            "Cache-Control: no-cache",
            "Pragma: no-cache",
            "SOAPAction: "

        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
        curl_setopt($ch, CURLOPT_URL, $ws);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_envio);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        // curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__)."/cacert.pem");
        $response = curl_exec($ch);
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $doc = new DOMDocument();
        $doc->loadXML($response);
        if (isset($doc->getElementsByTagName('codigoError')->item(0)->nodeValue)) {
            $codigoError = $doc->getElementsByTagName('codigoError')->item(0)->nodeValue;
            $descripcionError = $doc->getElementsByTagName('descripcionError')->item(0)->nodeValue;

            if ($codigoError == 0) {
                $idTransaccion = $doc->getElementsByTagName('idTransaccion')->item(0)->nodeValue;

                // $new_sintesis->id;

                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError,
                    'idTransaccion' => $idTransaccion,
                    // 'id' => $new_sintesis->id,
                ];
            } else {

                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError,
                    // 'id' => $new_sintesis->id,

                ];
            }
        } else {
            return 'error';
        }
    }
    public static function registraItem($idTransaccion, $precioUnitario)
    {
        $mes = date('m');
        $transaccion = 'A';
        $numeroPago = 1;
        $codigoProducto = 'PROD-' . $precioUnitario;
        //Items
        $numeroItem = 1; //Integer
        $descripcion = 'Enlace de Fibra Optica por servicio de comunicación mes de ' . $mes; //String
        // $precioUnitario = 0.0; //Double
        $cantidad = 1;
        $descuento = 0;
        $descuentoDuble = 0;

        // $cuenta = 'wsboldatasat';
        // $pass = 'WsBOLDATASAT21';
        $cuenta = 'wsboldatasat';
        $pass = 'Boldat2024';
        $xml_envio = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:ser="http://servicios.comelec.ws.sintesis.com.bo/">
        <soapenv:Header/>
        <soapenv:Body>
           <ser:registroItem>
              
              <datos>
              
                 <idTransaccion>' . $idTransaccion . '</idTransaccion>
              
                 <items>
              
                    <cantidad>' . $cantidad . '</cantidad>
              
                    <codigoProducto>' . $codigoProducto . '</codigoProducto>
              
                    <descripcion>' . $descripcion . '</descripcion>
              
                    <descuento>' . $descuento . '</descuento>
              
                    <descuentoDuble>' . $descuentoDuble . '</descuentoDuble>
              
                    <numeroItem>' . $numeroItem . '</numeroItem>
              
                    <precioUnitario>' . $precioUnitario . '</precioUnitario>
                 </items>
              
                 <numeroPago>' . $numeroPago . '</numeroPago>
              
                 <transaccion>' . $transaccion . '</transaccion>
              </datos>
              
              <cuenta>' . $cuenta . '</cuenta>
              
              <password>' . $pass . '</password>
           </ser:registroItem>
        </soapenv:Body>
     </soapenv:Envelope>';

        //PASO 05
        //ENVÍO DEL CPE A WS DE SUNAT

        //$ws = "http://test.sintesis.com.bo:80/WSApp-war/ComelecWS";
        $ws = "https://web.sintesis.com.bo:443/WSApp-war/ComelecWS"; //produccion
        $header = array(
            "Content-type: text/xml; charset=\"utf-8\"",
            "Accept: text/xml",
            "Cache-Control: no-cache",
            "Pragma: no-cache",
            "SOAPAction: "

        );

        $ch = curl_init();
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
        curl_setopt($ch, CURLOPT_URL, $ws);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_envio);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        // curl_setopt($ch, CURLOPT_CAINFO, dirname(__FILE__)."/cacert.pem");
        $response = curl_exec($ch);
        $httpcode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $doc = new DOMDocument();
        $doc->loadXML($response);
        if (isset($doc->getElementsByTagName('codigoError')->item(0)->nodeValue)) {
            $codigoError = $doc->getElementsByTagName('codigoError')->item(0)->nodeValue;
            $descripcionError = $doc->getElementsByTagName('descripcionError')->item(0)->nodeValue;
            if ($codigoError == 0) {
                return [
                    'codigoError' => $codigoError,
                    'descripcionError' => $descripcionError
                ];
            }
            return [
                'codigoError' => $codigoError,
                'descripcionError' => $descripcionError
            ];
        } else {
            return 'Error al registrar el Item';
        }
    }

    public static function obtenerTodosLosClientesWisproParaSintesis()
    {
        $page = 1;
        $per_page = 100;
        $responseTodosLosClientesWispro = Helpers::records_page($page, $per_page);
        $meta = $responseTodosLosClientesWispro['meta'];
        $pagination = $meta['pagination'];
        $total_pages = $pagination['total_pages'];
        $current_page = $pagination['current_page'];
        $cont = 0;

        for ($i = 0; $i < $total_pages; $i++) {
            $responseTodosLosClientesWispro = Helpers::records_page($current_page, $per_page);
            $dataClientes = $responseTodosLosClientesWispro['data'];
            $current_page++;
            foreach ($dataClientes as $cliente) {
                $obtenerPrecio = Helpers::obtenerPrecioDelContratoXClientId($cliente['id']); //probar

                $cont++;
                $clientes_custom_ids[] = [
                    'client_id' => $cliente['id'],
                    'custom_id' => $cliente['custom_id'],
                    'precio' => $obtenerPrecio
                ];
            }
        }
        return $clientes_custom_ids;
    }
}
