<?php

namespace App\Console\Commands;

use App\Helpers\Helpers;
use App\Models\Plan;
use Illuminate\Console\Command;
use Illuminate\Support\Facades\Log;
use Illuminate\Support\Facades\DB;
use App\Models\Planfull;
use App\Models\Smart;
use App\Models\Wisprocron;
use App\Models\Clienteswispro;
class SistCron extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'sist:cron';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Command description';

    /**
     * Execute the console command.
     */
    public function handle()
    {
        
        ini_set('max_execution_time', 360000);
        Log::channel('cronHabilitaDeshabilita')->info('Este log comenzo inicio a esta hora  ' . now());
        DB::beginTransaction();
        try {
            
            $smart = Smart::count();

            if ($smart > 0) {

                Smart::query()->delete();
                Wisprocron::query()->delete();
            }

            $listaEstadoOnus = Helpers::obtenerTodaListaOnusEstado();
            foreach ($listaEstadoOnus['onus'] as $onu) {
                $onus = new Smart();
                $onus->unique_external_id = $onu['unique_external_id'];
                $onus->onu_type_id = $onu['onu_type_id'];
                $onus->onu_type_name = $onu['onu_type_name'];
                $onus->wan_mode = $onu['wan_mode'];
                $onus->estado = true;
                $onus->save();
            }
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de SmartOLT  ' . now());
            $countWis = Wisprocron::count();
            if ($countWis > 0) {
                // DB::table('wisprocrons')->truncate();
                Wisprocron::query()->delete();
            }

            $plan_id = "";
            $precio = 138;

            $todosPlanes = Helpers::obtenerTodosLosPlanesWispro();
            //  return $todosPlanes['data'];
            $countPlanFull = Planfull::count();
            if ($countPlanFull > 0) {
                // DB::table('planfulls')->truncate();
                Planfull::query()->delete();
            }
            foreach ($todosPlanes['data'] as $plan) {
                $planfu = new Planfull();
                $planfu->id_plan = $plan['id'];
                $planfu->name = $plan['name'];
                $planfu->price = $plan['price'];
                $planfu->save();
                if ($plan['price'] == $precio) {
                    $plan_id = $plan['id'];
                }
            }
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de Planfull   ' . now());
            //Obtenemos todos los contratos de wispro con el plan 138 y todos los deshabilitados
            $listaTodosContratos = Helpers::obtenerTodosLosContratosWisproPlanODeshabilitadoBBDD($plan_id); //Guarda todo en BBDD


            $countClient = Clienteswispro::count();
            if ($countClient > 0) {
                // DB::table('clienteswispros')->truncate();
                Clienteswispro::query()->delete();
            }
            // if ($countClient == 0) {

            // ahora comparamos los solo los contratos y los actualizamos con el customID y name en la tabla Wisprocron
            $todosContratos = Wisprocron::select("plan_id", "client_id")->get();
            //return count($todosContratos);
            // ahora obtenemos todos los clientes
            $response = Helpers::obtenerTodosLosClientesWisproBBDD(); //Guarda todos los clientes en BBDD
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de Clienteswispro   ' . now());
            $todosLosClientesWispro = Clienteswispro::select("client_id", "custom_id", "name")->get();
            $con3 = 0;
            $con60 = 0;

            foreach ($todosContratos as $contrato) {
                # code...
                $con3++;
                foreach ($todosLosClientesWispro as $client) {
                    # code...
                    if ($contrato->client_id == $client->client_id) {
                        $con60++;
                        $cli = Wisprocron::where("client_id", $client->client_id)->first();
                        $cli->custom_id = $client->custom_id;
                        $cli->name = $client->name;
                        $cli->save();
                        // Log::channel('apagarOnus')->error($con60 . '.- clienteID:' . $client->client_id . ' customId:' . $client->custom_id . ' name: ' . $client->name);

                        break;
                    }
                }
            }
            Log::channel('cronHabilitaDeshabilita')->info('LLeno la tabla de Wisprocron cons custom_id y nombre    '  . now());
            // Obtenemos de la BD

            $modelo1 = "GP4442V9.0";
            $modelo2 = "UT-GP4442V9.0";
            $modelo3 = "YSD-101";
            $modelo4 = "XPON2GFRFW";
            $onusDeatils = Smart::where("onu_type_name", $modelo1)
                ->orWhere("onu_type_name", $modelo2)
                ->orWhere("onu_type_name", $modelo3)
                ->orWhere("onu_type_name", $modelo4)
                ->get();
            // ahora comparamos
            $wisproCron = Wisprocron::all();
            //   return $onusDeatils;
            $ar = [];
            $iii = 0;
            foreach ($wisproCron as $wispro) {
                # code...onusDeatils
                foreach ($onusDeatils as $onu) {
                    # code...
                    if ($wispro->custom_id == $onu->unique_external_id) {
                        $ar[] = $onu->unique_external_id;
                        $price2 = Planfull::select("price")->where("id_plan", $wispro->plan_id)->first();
                        $cli = Wisprocron::where("custom_id", $onu->unique_external_id)->first();
                        $cli->estado = true;
                        $cli->precio = $price2->price;
                        $iii++;
                        // Log::channel('cronHabilitaDeshabilita')->info('id::> ' . $iii . '  Cliente::>' . $wispro->custom_id . '  precio::>' . $cli->precio);
                        $cli->update();
                        break;
                    }
                }
            }

            Log::channel('cronHabilitaDeshabilita')->info('Termino de carga la informacion para el cron :: ' . now());
            $clientesCron = Wisprocron::where("estado", true)->get();
            Log::channel('cronHabilitaDeshabilita')->info('Cantidad de clientes en el cron :: ' . count($clientesCron));


            DB::commit();
           
         
        } catch (\Exception $e) {
              DB::rollback();
            Log::channel('cronHabilitaDeshabilita')->error('Hubo un error en la carga de informacion para el cron :: ' . now());
            Log::channel('cronHabilitaDeshabilita')->error($e);
        }
        // *************** CRON que deshabilitaba y habilitaba Anterior que se paro ***************************
    /*
        ini_set('max_execution_time', 36000);
        \Log::info("Mi cron " . now());


        $prueba = [

            array("client_id" => "cc15ad89-2b9d-4dd1-be9f-acb2137d5f0b", "custom_id" => "200020"),
            array("client_id" => "04fbb72b-6885-47b6-b3db-5bd03ad71026", "custom_id" => "200022"),
            array("client_id" => "a16b7dfd-20ee-4e57-8dc9-a0411aee0c01", "custom_id" => "200024"),

            array("client_id" => "6d2faf45-5770-46ab-9dae-a44530131390", "custom_id" => "200042"),
            array("client_id" => "3aa54cb8-ce91-44c2-8d0e-c857ef2fecd5", "custom_id" => "200044"),
            array("client_id" => "e7a3bfb4-c36b-4a14-b060-0918c98f2512", "custom_id" => "200047"),
            array("client_id" => "9d41b652-b7dd-4a8e-a917-a5b65285fd85", "custom_id" => "200041"),

        ];
        
        // custom_id 200020     286     deshabilitado    
        // custom_id 200022     258     deshabilitado
        // custom_id 200024     138     habilitado
        // custom_id 200042     178     deshabilitado
        // custom_id 200044     208     deshabilitado
        // custom_id 200047     258     habilitado
        // custom_id 200041     286     alerted


        // return $prueba;
        //{
        //    "client_id": "e67399f4-0fb7-4761-aea0-4c6c35b6d926",
        //    "custom_id": "210012"
        //},

        $TodosLosClientesWispro = Helpers::obtenerTodosLosClientesWispro();
        \Log::info('Cantidad de clientes::>' . count($TodosLosClientesWispro));
        $plan = Plan::find(1);
        $plan2 = Plan::find(2);
        $plan3 = Plan::find(3);
        
        $plan->precio;
        $plan2->precio;
        $plan3->precio;
        $cont=0;
        
        //$uuid = 'efd44de5-6b2f-4a98-9cc5-6f501b605933';
        //tiene => estado, precio por cliente
        //  $estadoContrato = Helpers::obtenerEstadoDelContratosXuuid($TodosLosClientesWispro['client_id']);
        //$estadoContrato = Helpers::obtenerEstadoDelContratosXuuid($uuid);
        // {
        //     "state": "alerted",
        //     "precio": 138
        // }
        // 100 138 siempre deshabilitados SMART deshabilitado
        //siempre que se a mayor a 178 y este alertado o habilitado en wiaspro en smart habilitado catTV

        foreach ($TodosLosClientesWispro as $cliente) {
            //foreach ($prueba as $cliente) {
            sleep(2);
            $estadoContrato = Helpers::obtenerEstadoDelContratosXuuid($cliente['client_id']);

            if ($estadoContrato['precio'] > $plan->precio || $estadoContrato['precio'] == $plan2->precio || $estadoContrato['precio'] == $plan3->precio) {
                if ($estadoContrato['state'] == 'enabled') {
                    $cont++;
                    sleep(2);
                    Helpers::habilitar_cattv($cliente['custom_id']);
                    \Log::info('#'. $cont.'::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: enabled');
                } elseif ($estadoContrato['state'] == 'disabled') {
                    $cont++;
                    sleep(2);
                    Helpers::deshabilitar_cattv($cliente['custom_id']);
                    \Log::info('#'. $cont.'::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: disabled');
                } elseif ($estadoContrato['state'] == 'alerted') {
                        $cont++;
                        sleep(2);
                      Helpers::habilitar_cattv($cliente['custom_id']);
                    \Log::info('#'. $cont.'::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: enabled');
                }
            } else {
                $cont++;
                sleep(2);
                Helpers::deshabilitar_cattv($cliente['custom_id']);
                \Log::info('#'. $cont.'::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: disabled');

            }
        }
*/
/* Emergencias */
/*
$conta = 1;

        foreach ($TodosLosClientesWispro as $cliente) {
            // foreach ($prueba as $cliente) {

            if ($conta > 948) {
                $estadoContrato = Helpers::obtenerEstadoDelContratosXuuid($cliente['client_id']);

                if ($estadoContrato['precio'] > $plan->precio || $estadoContrato['precio'] == $plan2->precio || $estadoContrato['precio'] == $plan3->precio) {
                    if ($estadoContrato['state'] == 'enabled') {
                        $cont++;
                        Helpers::habilitar_cattv($cliente['custom_id']);
                        \Log::info('#' . $cont . '::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: enabled');
                    } elseif ($estadoContrato['state'] == 'disabled') {
                        $cont++;
                        Helpers::deshabilitar_cattv($cliente['custom_id']);
                        \Log::info('#' . $cont . '::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: disabled');
                    } elseif ($estadoContrato['state'] == 'alerted') {
                        $cont++;
                        Helpers::habilitar_cattv($cliente['custom_id']);
                        \Log::info('#' . $cont . '::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: enabled');
                    }
                } else {
                    $cont++;
                    Helpers::deshabilitar_cattv($cliente['custom_id']);
                    \Log::info('#' . $cont . '::Plan:' . $estadoContrato['precio'] . '::Estado wispro:' . $estadoContrato['state'] . ':: CustomId:' . $cliente['custom_id'] . ' :: Smart:: disabled');
                }
            }
            $conta++;
        }

        // return response()->json([
        //     'Success' => true,
        //     'mensaje' => 'Actualizacion correcta',
        // ], 200);


*/
    }
}