<?php

namespace App\Events;

use App\Models\PagoSintesi;
use Illuminate\Broadcasting\Channel;
use Illuminate\Broadcasting\InteractsWithSockets;
use Illuminate\Broadcasting\PresenceChannel;
use Illuminate\Broadcasting\PrivateChannel;
use Illuminate\Contracts\Broadcasting\ShouldBroadcast;
use Illuminate\Foundation\Events\Dispatchable;
use Illuminate\Queue\SerializesModels;

class RegisterPagosNetEvent
{
    use Dispatchable, InteractsWithSockets, SerializesModels;
    public PagoSintesi $pagoSintesis;
    /**
     * Create a new event instance.
     */
    public function __construct(PagoSintesi $pagoSintesis)
    {
        //
        $this->pagoSintesis = $pagoSintesis;
    }

    /**
     * Get the channels the event should broadcast on.
     *
     * @return array<int, \Illuminate\Broadcasting\Channel>
     */
    public function broadcastOn(): array
    {
        return [
            new PrivateChannel('channel-name'),
        ];
    }
}
