<?php

namespace App\Http\Controllers;

use App\Models\Qr;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;

class QrController extends Controller
{
    //
    public function crear_qr(Request $request)
    {
        date_default_timezone_set('America/La_Paz');
        $todayDate = date('Y-m-d');
        // validando
        $infoData = $request->validate([


            "amount" => "required|integer",

            "expirationDate" => "required",

            //Valida la fecha de hoy

            // "TransactionDateTime" => 'required| after:' . date('Y-m-d'),
            // "TransactionDateTime" => "date",
        ], [
            'amount.required' => 'EL monto es requerido',
            'amount.integer' => 'EL monto tiene que ser entero',
            'TransactionDateTime.required' => 'La fecha es requerida',
            'TransactionDateTime.date_format' => 'El formato de la fecha es Año-mes-dia',
            'TransactionDateTime.date_equals' => 'La fecha is incorrecta, tiene que tener la fecha de hoy'
        ]);
        //validamos el epago




        // guardar en la BD
        DB::beginTransaction();
        try {
            $qr = new Qr();
            $qr->currency = $request->currency;
            $qr->gloss = $request->gloss;
            $qr->amount = $request->amount;
            $qr->expirationDate = $request->expirationDate;
            $qr->singleUse = $request->singleUse;
            $qr->additionalData = $request->additionalData;
            $qr->destinationAccountId = $request->destinationAccountId;
            $qr->save();
            DB::commit();
            // responder
            return response()->json([
                'success' => true,
                'message' => 'Qr. registrado conrrectamente'
            ], 201);
        } catch (\Exception $e) {
            DB::rollBack();
            return response()->json([
                "status" => false,
                "mensaje" => "Error al crear el Qr..",

            ], 422);
        }
        /*


        $token = Helpers::tokenAuthBnb();

        $fecha = date('Y-m-d');

        $tokenData = json_decode($token);
        $token = $tokenData->message;
        $authorization = 'Bearer ' . $token;
        //dd($authorization);
        $url = 'http://test.bnb.com.bo/QRSimple.API/api/v1/main/CancelQRByIdAsync';
        $responseAuth = Http::withHeaders([
            'Authorization' => $authorization,
            'Content-Type' => 'application/json',
            'Accept' => 'application/json',

        ])->post($url, [
            //  "qrId" => $id
        ]);


        $datosPago = json_decode($responseAuth);
        $token = $datosPago->message;
        // dd($token);
        return response()->json($datosPago, 200);
        */
    }
}
