<?php

namespace App\Http\Controllers;

use App\Events\RegistrarPagoSintesisEvent;
use App\Helpers\Helpers;
use App\Models\CodigoRecaudacion;
use App\Models\PagoSintesi;
use App\Models\Sintesi;
use Carbon\Carbon;
use DOMDocument;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\DB;
use DateTime;
use Illuminate\Support\Facades\Auth;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Log;

class SintesiController extends Controller
{
    //
    public function cargar_datos_info($qrId, Request $request)
    {
        /*
		$xml = '<?xml version="1.0" encoding="utf-8" ?>
<factura>
    <serie>FOO1</serie>
    <correlativo>' . $qrId . '</correlativo>
    <fecha>2023-09-26</fecha>
    <cliente>
        <documento tipo="ruc">10459336635</documento>
        <nombre>ANTONIO FUENTES</nombre>
        <direccion>PERU</direccion>
    </cliente>
    <emisor>
        <razonsocial>ISI</razonsocial>
        <ruc>23454654567</ruc>
    </emisor>
    <item>
        <orden>1</orden>
        <producto>GALLETAS</producto>
        <unidad>PAQ</unidad>
        <cantidad>2</cantidad>
        <precio>2.50</precio>
    </item>
    <item>
        <orden>2</orden>
        <producto>GASEOSAS</producto>
        <unidad>UND</unidad>
        <cantidad>1</cantidad>
        <precio>4.50</precio>
    </item>
    <item>
        <orden>3</orden>
        <producto>GASEOSAS 2</producto>
        <unidad>UND</unidad>
        <cantidad>10</cantidad>
        <precio>44.50</precio>
    </item>
</factura>';
$doc = new DOMDocument();
$doc->formatOutput = FALSE;
$doc->preserveWhiteSpace = TRUE;
$doc->encoding = 'utf-8';

$doc->loadXML($xml);
//para leer los tags o los items
$items = $doc->getElementsByTagName('item');
foreach ($items as $item) {
$producto = $item->getElementsByTagName('producto')->item(0)->nodeValue;
echo $producto . '<br>';
}

$total = $doc->createElement("total", "100");
$doc->getElementsByTagName('item')->item(1)->appendChild($total);


$doc->save('FACTURA' . $qrId . '.XML');

*/
$categoriaProducto = 1;
$codigoComprador = '200044';
$codigoRecaudacion = 8;
$correoElectronico = 'antonio@gmail.com';
$descripcionRecaudacion = 'Servicio Internet mes de octubre';

$documentoIdentidadComprador = '1234569';

$fecha = 20231019;
$fechaVencimiento = 0;
$hora = 000340;
$horaVencimiento = 0;
$moneda = 'BS';
$nombreComprador = 'Antonio pruebas';
$descripcion = 'Servicio Internet mes de octubre';
$montoCreditoFiscal = 100.0;
$montoPago = 100.0;
$nitFactura = '1234569';
$nombreFactura = 'Antonio pruebas';
$numeroPago = 1;
$precedenciaCobro = 'N';
$transaccion = 'A';





/*
$cdr = base64_decode($cdr);
file_put_contents($carpetacdr."R-".$nombrezip, $cdr);
$zip = new ZipArchive;
if($zip->open($carpetacdr."R-".$nombrezip)===true){
$zip->extractTo($carpetacdr.'R-'.$nombrexml);
$zip->close();
}
//LEEMOS EL CDR
$docCDR = new DOMDocument();
$cdrContent = file_get_contents($carpetacdr.'R-'.$nombrexml.'/'.'R-'.$nombrexml.'.XML');
$docCDR->loadXML($cdrContent);

$responseCode = $docCDR->getElementsByTagName("ResponseCode")->item(0)->nodeValue;

if($responseCode==0){
echo "FACTURA APROBADA";
}else{
echo "FACTURA RECHAZADA CON CODIGO DE ERROR:".$responseCode;
}

echo "<br />";
echo $docCDR->getElementsByTagName("Description")->item(0)->nodeValue;

}else{
$codigo = $doc->getElementsByTagName("faultcode")->item(0)->nodeValue;
$mensaje = $doc->getElementsByTagName("faultstring")->item(0)->nodeValue;
echo "error ".$codigo.": ".$mensaje;
}
return $doc;
*/
}

public function lista()
{
// $this->authorize("viewAny_role");

//$roles = Role::get();
$sintesis = Sintesi::all();

return response()->json([
"success" => true,
"data" => $sintesis
], 200);
}
public function listapagos()
{
// $this->authorize("viewAny_role");

//$roles = Role::get();
$pago_sintesis = PagoSintesi::all();

return response()->json([
"success" => true,
"data" => $pago_sintesis
], 200);
}

public function cargar_datos($id, Request $request)
{


Log::channel('sintesis')->info("Envio a Sintesis " . now());
$rec = CodigoRecaudacion::find(1);
$codigoRecaudacion2 = $rec->cod_recaudacion;



/*
$rec = new CodigoRecaudacion();
$rec->cod_recaudacion = 250;
$rec->save();
return $rec;
*/


$page = 1;
$per_page = 20;
// $responseTodosLosClientesWispro = Helpers::records_page(1, 2);
$responseTodosLosClientesWispro = Helpers::records_page($page, $per_page);
$meta = $responseTodosLosClientesWispro['meta'];
$pagination = $meta['pagination'];
$total_pages = $pagination['total_pages'];
$current_page = $pagination['current_page'];
$cont = 0;

$dataClientes = $responseTodosLosClientesWispro['data'];
Log::channel('sintesis')->info('Cantidad de clientes::>' . count($dataClientes));
// return $dataClientes;
for ($i = 0; $i < $total_pages; $i++) { $responseTodosLosClientesWispro=Helpers::records_page($current_page, $per_page);
    $dataClientes=$responseTodosLosClientesWispro['data']; $current_page++; foreach ($dataClientes as $cliente) {
    $obtenerPrecio=Helpers::obtenerPrecioDelContratoXClientId($cliente['id']); //probar
    $correoElectronico=$cliente['email']==null ? '' : $cliente['email'];
    $documentoIdentidadComprador=$cliente['national_identification_number']; $nombreComprador=$cliente['name'];
    $codigoComprador=$cliente['custom_id']; $montoCreditoFiscal=$obtenerPrecio; $montoPago=$obtenerPrecio;
    $nitFactura=$cliente['national_identification_number']; $nombreFactura=$cliente['name'];
    $codigoRecaudacion=$codigoRecaudacion2; //guardar $registroAlta=Helpers::registraAlta( $id, $correoElectronico,
    $documentoIdentidadComprador, $nombreComprador, $codigoComprador, $montoCreditoFiscal, $montoPago, $nitFactura,
    $nombreFactura, $codigoRecaudacion, ); $codigoRecaudacion2++; //return $registroAlta; if
    ($registroAlta['codigoError']==0) { $cont++; $idTransaccion=$registroAlta['idTransaccion'];
    $registroItem=Helpers::registraItem($idTransaccion, $montoPago); $new_sintesis=Sintesi::find($registroAlta['id']);
    if ($registroItem['codigoError']==0) { Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:'
    . $nombreComprador . ':: codRe:' . $codigoRecaudacion);

    $new_sintesis->idTransaccion = $idTransaccion;
    $new_sintesis->codigoError = $registroAlta['codigoError'];
    $new_sintesis->descripcionError = $registroAlta['descripcionError'];
    $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
    $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];
    $new_sintesis->update();

    // return [
    // $registroAlta['codigoError'],
    // $registroAlta['descripcionError'],
    // $registroAlta['idTransaccion'],
    // $registroItem['codigoError'],
    // $registroItem['descripcionError'],
    // ];
    } else {
    $message = 'Error al registrar el item';
    Log::channel('sintesis')->info('CustomId:' . $codigoComprador . ':: Nombre:' . $nombreComprador . ':: codRe:' .
    $codigoRecaudacion);
    $new_sintesis->codigoErrorItem = $registroItem['codigoError'];
    $new_sintesis->descripcionErrorItem = $registroItem['descripcionError'];

    $new_sintesis->update();
    // return [
    // $message,
    // $registroItem['codigoError'],
    // $registroItem['descripcionError'],
    // ];
    }
    } else {
    // todo Guardar el error en la BD
    $message = 'Error al cargar info en sintesis';
    $update_sintesis = Sintesi::find($registroAlta['id']);
    $update_sintesis->codigoError = $registroAlta['codigoError'];
    $update_sintesis->descripcionError = $registroAlta['descripcionError'];
    $update_sintesis->update();
    /*
    return [
    $message,
    $registroAlta['codigoError'],
    $registroAlta['descripcionError'],
    ];
    */
    }
    }
    }
    $rec->cod_recaudacion = $codigoRecaudacion2;
    $rec->update();
    Log::channel('sintesis')->info('Se enviaron :::' . count($dataClientes) . ' :::::::::::>' . $cont);
    return response()->json([
    'codError' => 0,
    'descripcion' => "Registros enviados a Sintesis Correctamente",
    ], 201, [], JSON_UNESCAPED_UNICODE);
    }
    public function crear_notificacion_sintesis(Request $request)
    {
    $todos_los_datos = $request->all();

    // $credenciales = $request->validate([
    // "usuario" => "required",
    // "clave" => "required",
    // "codigoEmpresa" => "required"
    // ]);
    if (!Auth::attempt(['name' => $todos_los_datos['usuario'], 'password' => $todos_los_datos['clave'], 'cuenta' =>
    $todos_los_datos['codigoEmpresa']])) {
    return response()->json([
    'codError' => 1,
    'descripcion' => "Credenciales incorrectas",
    ], 401, [], JSON_UNESCAPED_UNICODE);
    // ], 401);
    }

    //Verificamos si el codigo de recaudacion existe en la BD


    //$codigoRecaudacion = Sintesi::where("codigoRecaudacion", $todos_los_datos['codigoRecaudacion'])->count();


    //return $codigoRecaudacion->codigoRecaudacion;
    /*
    if ($codigoRecaudacion == 0) {
    return response()->json([
    'codError' => 1,
    'descripcion' => "Error no existe codigo de recaudacion",
    ], 422, [], JSON_UNESCAPED_UNICODE);
    // ], 401);
    }
    */
    // Registramos en la BD el Pago
    DB::beginTransaction();
    try {
    $new_pago = new PagoSintesi();
    $new_pago->codigoRecaudacion = $todos_los_datos['codigoRecaudacion'];
    $new_pago->codigoProducto = $todos_los_datos['codigoProducto'];
    $new_pago->numeroPago = $todos_los_datos['numeroPago'];
    $new_pago->fecha = $todos_los_datos['fecha'];
    $new_pago->secuencial = $todos_los_datos['secuencial'];
    $new_pago->hora = $todos_los_datos['hora'];
    $new_pago->origenTransaccion = $todos_los_datos['origenTransaccion'];
    $new_pago->pais = $todos_los_datos['pais'];
    $new_pago->departamento = $todos_los_datos['departamento'];
    $new_pago->ciudad = $todos_los_datos['ciudad'];
    $new_pago->entidad = $todos_los_datos['entidad'];
    $new_pago->agencia = $todos_los_datos['agencia'];
    $new_pago->operador = $todos_los_datos['operador'];
    $new_pago->monto = $todos_los_datos['monto'];
    $new_pago->loteDosificacion = $todos_los_datos['loteDosificacion'];
    $new_pago->nroRentaRecibo = $todos_los_datos['nroRentaRecibo'];
    $new_pago->montoCreditoFiscal = $todos_los_datos['montoCreditoFiscal'];
    $new_pago->codigoAutorizacion = $todos_los_datos['codigoAutorizacion'];
    $new_pago->codigoControl = $todos_los_datos['codigoControl'];
    $new_pago->nitFacturar = $todos_los_datos['nitFacturar'];
    $new_pago->nombreFacturar = $todos_los_datos['nombreFacturar'];
    $new_pago->transaccion = $todos_los_datos['transaccion'];
    $new_pago->save();
    DB::commit();
    // RegistrarPagoSintesisEvent::dispatch($new_pago);

    return response()->json([
    'codError' => 0,
    'descripcion' => "Registro exitoso",
    ], 201, [], JSON_UNESCAPED_UNICODE);
    } catch (\Exception $e) {

    DB::rollBack();

    return response()->json([
    'codError' => 1,
    'descripcion' => "Error al registrar el pago",


    ], 422, [], JSON_UNESCAPED_UNICODE);
    }
    }
    public function getLogs()
    {
    $logFilePath = storage_path('logs/sintesis.log');
    $logs = file_exists($logFilePath) ? file_get_contents($logFilePath) : 'Log file not found.';
    return response()->json(['logs' => $logs]);
    }
    public function delete_datos()
    {

    return "Hola cuate ";
    }
    }