<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('clients', function (Blueprint $table) {
            $table->id();
            $table->string('id_wispro');
            // $table->integer('public_id');
            $table->string('custom_id');
            $table->string('name');
            $table->string('email')->nullable();
            $table->string('address')->nullable();
            $table->string('phone_mobile')->nullable();
            $table->string('national_identification_number');
            $table->string('city')->nullable();
            $table->string('state')->nullable();
            // $table->boolean('statusfactura')->dafault(false); //false=no factura ; true= factura
            $table->string('details')->nullable();
            // $table->dateTime('created_at_wispro');

            //relacion user cliente 1:1
            $table->bigInteger('user_id')->unsigned();
            $table->foreign('user_id')->references('id')->on('users');


            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('clients');
    }
};