<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('qrs', function (Blueprint $table) {
            $table->id();
            $table->string('currency');
            $table->string('qr_id')->nullable();
            $table->string('gloss')->nullable();
            $table->integer('amount')->unsigned();
            $table->dateTime('expirationDate');
            $table->boolean('singleUse')->nullable();
            $table->string('additionalData')->nullable();
            $table->integer('destinationAccountId')->nullable();

            $table->bigInteger('client_id')->unsigned();
            $table->foreign('client_id')->references('id')->on('clients');
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('qrs');
    }
};