<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     */
    public function up(): void
    {
        Schema::create('factura_user', function (Blueprint $table) {
            $table->id();

            $table->string('numeroFactura');
            $table->string('montoFactura');

            $table->bigInteger("factura_id")->unsigned();
            $table->bigInteger("user_id")->unsigned();
            //Relacion
            $table->foreign("factura_id")->references("id")->on("facturas");
            $table->foreign("user_id")->references("id")->on("users");
            $table->timestamps();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void
    {
        Schema::dropIfExists('factura_user');
    }
};
